#ifdef CH_LANG_CC
/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
//
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
#endif

#if (CH_SPACEDIM == 2)

#define QRHO  0
#define QVELX 1
#define QVELY 2
#define QPRES 3
#define QENTR 4
#define QC 5
#ifdef MODIANO_PROBLEM
#define QMVAX 6
#define QMVTN 7
#define QNUM  8
#define QSLOPE 8
#else
#define QNUM  6
#define QSLOPE 6
#endif
#define CRHO  0
#define CMOMX 1
#define CMOMY 2
#define CENG  3
#define CNUM  4

#ifdef RZ_COORDS
#define FNUM  5
#define CPRES 4
#else
#define FNUM  4
#define CPRES 0
#endif

#endif

#if (CH_SPACEDIM == 3)
#define CPRES 0

#define QRHO  0
#define QVELX 1
#define QVELY 2
#define QVELZ 3
#define QPRES 4
#define QENTR 5
#define QC    6
#ifdef MODIANO_PROBLEM
#define QMVAX 7
#define QMVTN1 8
#define QMVTN2 9
#define QNUM  10
#define QSLOPE 10
#else
#define QNUM  7
#define QSLOPE 7
#endif


#define CRHO  0
#define CMOMX 1
#define CMOMY 2
#define CMOMZ 3
#define CENG  4
#define CNUM  5
#define FNUM  5
#endif
