/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
//
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//


#ifndef _EBPlanarShockIBCFACTORY_H
#define _EBPlanarShockIBCFACTORY_H

#include "EBPlanarShockIBC.H"
#include "EBCellFAB.H"
#include "EBFaceFAB.H"
#include "REAL.H"
#include "LevelData.H"
#include "ProblemDomain.H"
#include "EBPhysIBC.H"
#include "EBPlanarShockIBC.H"
#include "EBPhysIBCFactory.H"

///
/**
 */
class EBPlanarShockIBCFactory: public EBPhysIBCFactory
{
public:

  ///
  ~EBPlanarShockIBCFactory();

  ///
  EBPlanarShockIBCFactory(const Real&     a_gamma,
                          const Real&     a_ms,
                          const Real&     a_center,
                          const int&      a_shocknorm,
                          const bool&     a_shockbackward,
                          const bool&     a_doRZCoords);

  ///
  EBPhysIBC* create() const;

protected:
  Real m_gamma;
  Real m_ms;
  Real m_center;
  int  m_shocknorm;
  bool m_shockbackward;
  bool m_doRZCoords;
private:
  EBPlanarShockIBCFactory()
  {
    MayDay::Error("Invalid operator");
  }
  
  void operator=(const EBPlanarShockIBCFactory& a_input)
  {
    MayDay::Error("Invalid operator");
  }
  
  EBPlanarShockIBCFactory(const EBPlanarShockIBCFactory& a_input)
  {
    MayDay::Error("Invalid operator");
  }
  

};

#endif
