/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
//
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//

#include "EBPlanarShockIBCFactory.H"
#include "EBPlanarShockIBC.H"
/******************/
/******************/
EBPlanarShockIBCFactory::
EBPlanarShockIBCFactory(const Real&     a_gamma,
                        const Real&     a_ms,
                        const Real&     a_center,
                        const int&      a_shocknorm,
                        const bool&     a_shockbackward,
                        const bool&     a_doRZCoords)
  :EBPhysIBCFactory()
{
  m_gamma         = a_gamma;
  m_ms            = a_ms;   
  m_center        = a_center;
  m_shocknorm     = a_shocknorm;
  m_shockbackward = a_shockbackward;
  m_doRZCoords    = a_doRZCoords;
}
/******************/
/******************/

EBPlanarShockIBCFactory::
~EBPlanarShockIBCFactory()
{;}
/******************/
/******************/
EBPhysIBC*
EBPlanarShockIBCFactory::
create() const
{
  EBPlanarShockIBC* retval = 
    new EBPlanarShockIBC(m_gamma,
                         m_ms,
                         m_center,
                         m_shocknorm,
                         m_shockbackward,
                         m_doRZCoords);
  return static_cast<EBPhysIBC*>(retval);
}
/******************/
/******************/

