/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
//
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//


#ifndef _ModianoIBCFACTORY_H
#define _ModianoIBCFACTORY_H

#include "ModianoIBC.H"
#include "EBCellFAB.H"
#include "EBFaceFAB.H"
#include "REAL.H"
#include "LevelData.H"
#include "ProblemDomain.H"
#include "EBPhysIBC.H"
#include "ModianoIBC.H"
#include "EBPhysIBCFactory.H"

///
/**
 */
class ModianoIBCFactory: public EBPhysIBCFactory
{
public:

  ///
  ~ModianoIBCFactory();

  ///
  ModianoIBCFactory(const Real&     a_gamma,
                    const Real&     a_waveAmp,
                    const Real&     a_waveWidth,
                    const RealVect& a_center,
                    const RealVect& a_waveDir,
                    bool   a_freeStreamOnly,
                    bool   a_useNegWave = false );

  ///
  EBPhysIBC* create() const;

protected:
  Real     m_gamma;
  Real     m_waveAmp;
  Real     m_waveWidth;
  RealVect m_waveDir;
  RealVect m_center;
  bool     m_freeStreamOnly;
  bool     m_useNegWave;

private:
  ModianoIBCFactory()
  {
    MayDay::Error("Invalid operator");
  }
  
  void operator=(const ModianoIBCFactory& a_input)
  {
    MayDay::Error("Invalid operator");
  }
  
  ModianoIBCFactory(const ModianoIBCFactory& a_input)
  {
    MayDay::Error("Invalid operator");
  }
  

};

#endif
