#!/bin/csh -f
if ($#argv < 1) then
  echo "Usage:  getsummary.csh name [dim [dir]]"
  exit 1
endif
set name=$1
endif
set dim=2
if ($#argv >= 2) then
  set dim=$2
endif
set dir=results
if ($#argv >= 3) then
  set dir=$3
endif
set freqxall=(2.62 4.42 6.22)
set freqyall=(2.24 4.64 6.44)
set freqzall=(2.46 4.26 6.66)
echo ""
awk -f getsummary.title.awk dim="$dim" < /dev/null
foreach f (`ls $dir/runone.${dim}d.${name}.*.rate`)
  set root=$f:r
  set trig=$root:e
  set freqx=`echo $trig | awk '{printf("%s",substr($1,1,1));}'`
  set freqy=`echo $trig | awk '{printf("%s",substr($1,2,1));}'`
  if ($dim == 2) then
    set freqz=0
  else
    set freqz=`echo $trig | awk '{printf("%s",substr($1,3,1));}'`
  endif
  set printone=1
  if ($dim == 2) then
    echo "$freqxall[$freqx] $freqyall[$freqy]" | awk -f getsummary.trig.awk
    tail -1 $dir/runone.${dim}d.$name.${freqx}${freqy}.error > getsummary.temp
    tail -1 $dir/runone.${dim}d.$name.${freqx}${freqy}.rate >> getsummary.temp
    awk -f getsummary.results.awk < getsummary.temp
  else
    echo "$freqxall[$freqx] $freqyall[$freqy] $freqzall[$freqz]" | awk -f getsummary.trig.awk
    tail -1 $dir/runone.${dim}d.$name.${freqx}${freqy}${freqz}.error > getsummary.temp
    tail -1 $dir/runone.${dim}d.$name.${freqx}${freqy}${freqz}.rate >> getsummary.temp
    awk -f getsummary.results.awk < getsummary.temp
  endif
end
/bin/rm -f getsummary.temp
