#!/bin/csh -f
if ($#argv < 1) then
  echo "Usage:  getsummary.csh name [dim [dir]]"
  exit 1
endif
set name=$1
endif
set dim=2
if ($#argv >= 2) then
  set dim=$2
endif
set dir=results
if ($#argv >= 3) then
  set dir=$3
endif
set expoall=(4)
set freqall=(3)
echo ""
awk -f getsummary.title.awk dim="$dim" < /dev/null
foreach f (`ls $dir/runone.${dim}d.${name}.*.rate`)
  set root=$f:r
  set param=$root:e
  set expo=`echo $param | awk '{printf("%s",substr($1,1,1));}'`
  set freq=`echo $param | awk '{printf("%s",substr($1,2,1));}'`
  if ($dim == 2) then
    set z=0
  else
    set z=`echo $param | awk '{printf("%s",substr($1,3,1));}'`
  endif
  set printone=1
  if ($dim == 2) then
    echo "$expoall[$expo] $freqall[$freq]" | awk -f getsummary.johan.awk
    tail -1 $dir/runone.${dim}d.$name.${expo}${freq}.error > getsummary.temp
    tail -1 $dir/runone.${dim}d.$name.${expo}${freq}.rate >> getsummary.temp
    awk -f getsummary.results.awk < getsummary.temp
  else
    echo "$expoall[$expo] $freqall[$freq] 0" | awk -f getsummary.johan.awk
    tail -1 $dir/runone.${dim}d.$name.${expo}${freq}${z}.error > getsummary.temp
    tail -1 $dir/runone.${dim}d.$name.${expo}${freq}${z}.rate >> getsummary.temp
    awk -f getsummary.results.awk < getsummary.temp
  endif
end
/bin/rm -f getsummary.temp
