#!/bin/csh -f
if ($#argv < 1) then
  echo "Usage:  getsummary.csh name [dim [dir [maxpow]]]"
  exit 1
endif
set name=$1
endif
set dim=2
if ($#argv >= 2) then
  set dim=$2
endif
set dir=results
if ($#argv >= 3) then
  set dir=$3
endif
set maxpow=`expr 4 \* $dim`
if ($#argv >= 4) then
  set maxpow=$4
endif
echo ""
awk -f getsummary.title.awk < /dev/null
set pow=0
while ($pow <= $maxpow)
  set printone=0
  foreach f (`ls -r $dir/runone.${dim}d.${name}.*.rate`)
    set root=$f:r
    set mono=$root:e
    set px=`echo $mono | awk '{printf("%s",substr($1,1,1));}'`
    set py=`echo $mono | awk '{printf("%s",substr($1,2,1));}'`
    if ($dim == 2) then
      set pz=0
    else
      set pz=`echo $mono | awk '{printf("%s",substr($1,3,1));}'`
    endif
    set sumpow=`expr $px + $py + $pz`
    if ($sumpow == $pow) then
      set printone=1
      if ($dim == 2) then
        echo "$px $py" | awk -f getsummary.power.awk
        tail -1 $dir/runone.${dim}d.$name.${px}${py}.error > getsummary.temp
        tail -1 $dir/runone.${dim}d.$name.${px}${py}.rate >> getsummary.temp
        awk -f getsummary.results.awk < getsummary.temp
      else
        echo "$px $py $pz" | awk -f getsummary.power.awk
        tail -1 $dir/runone.${dim}d.$name.${px}${py}${pz}.error > getsummary.temp
        tail -1 $dir/runone.${dim}d.$name.${px}${py}${pz}.rate >> getsummary.temp
        awk -f getsummary.results.awk < getsummary.temp
      endif
    endif
  end
  if ($printone == 1) then
    echo ""
  endif
  @ pow++
end
/bin/rm -f getsummary.temp
