#!/bin/csh -f
#
# Run one set of tests
#
set start=0
set sizemin=32
if ($?sizemax == 0) then
  if ($dim == "2d") then
    set sizemax=1024
  else
    set sizemax=128
  endif
endif
set size=$sizemin
set lsingxall=($singxall)
set lsingyall=($singyall)
set lsingzall=($singzall)
set singxmax=$#lsingxall
set singymax=$#lsingyall
set singzmax=$#lsingzall
while ($size <= $sizemax)
  echo "Size: $size"
  set singx=1
  while ($singx <= $singxmax)
    set singy=1
    while ($singy <= $singymax)
      if ($dim == "2d") then
        if ($size == $ssize && $singx == $ssingx && $singy == $ssingy) then
          set start=1
        endif
        if ($start == 1 && ($singx != 2 || $singy != 2)) then
          set singz=1
          if ($size == $sizemin) then
            /bin/rm -f $dir/runone.$dim.$name.${singx}${singy}.raw
          endif
          echo "  Singularity: $lsingxall[$singx] $lsingyall[$singy]" \
          | awk '{printf("  %s %5.2f %5.2f\n",$1,$2,$3)}'
          sed -e "s/GEOM/$geom/"               \
              -e "s/CYCLE/$cycle/"             \
              -e "s/PX/$px/"                   \
              -e "s/PY/$py/"                   \
              -e "s/PZ/$pz/"                   \
              -e "s/NX/$nx/"                   \
              -e "s/NY/$ny/"                   \
              -e "s/NZ/$nz/"                   \
              -e "s/RADIUS/$radius/"           \
              -e "s/CX/$cx/"                   \
              -e "s/CY/$cy/"                   \
              -e "s/CZ/$cz/"                   \
              -e "s/INT/$int/"                 \
              -e "s/PRAD/$prad/"               \
              -e "s/PCENTX/$pcentx/"           \
              -e "s/PCENTY/$pcenty/"           \
              -e "s/PCENTZ/$pcentz/"           \
              -e "s/PPERT/$ppert/"             \
              -e "s/PFREQ/$pfreq/"             \
              -e "s/SINGX/$lsingxall[$singx]/" \
              -e "s/SINGY/$lsingyall[$singy]/" \
              -e "s/SINGZ/$lsingzall[$singz]/" \
              -e "s/EBBC/$ebbc/"               \
              -e "s/DOMBC/$dombc/"             \
              -e "s/NUMX/$size/"               \
              -e "s/NUMY/$size/"               \
              -e "s/NUMZ/$size/"               \
              < runone.proto > runone.$dim.inputs
          multigridTest$dim.Linux.g++.g77.ex runone.$dim.inputs \
            > runone.$dim.output
          grep '(final)' runone.$dim.output \
            >> $dir/runone.$dim.$name.${singx}${singy}.raw
          set zsize=`echo $size | awk '{printf("%04d",$1);}'`
          mv error.hdf5 $dir/error.$dim.$name.${singx}${singy}.$zsize.hdf5
          (gzip -f $dir/error.$dim.$name.${singx}${singy}.$zsize.hdf5 &) >&! /dev/null
        endif
      else
        set singz=1
        while ($singz <= $singzmax)
          if ($size == $ssize && $singx == $ssingx && $singy == $ssingy && $singz == $ssingz) then
            set start=1
          endif
          if ($start == 1 && ($singx != 2 || $singy != 2 || $singz != 2)) then
            if ($size == $sizemin) then
              /bin/rm -f $dir/runone.$dim.$name.${singx}${singy}${singz}.raw
            endif
            echo "  Singularity: $lsingxall[$singx] $lsingyall[$singy] $lsingzall[$singz]" \
            | awk '{printf("  %s %5.2f %5.2f %5.2f\n",$1,$2,$3,$4)}'
            sed -e "s/GEOM/$geom/"               \
                -e "s/CYCLE/$cycle/"             \
                -e "s/PX/$px/"                   \
                -e "s/PY/$py/"                   \
                -e "s/PZ/$pz/"                   \
                -e "s/NX/$nx/"                   \
                -e "s/NY/$ny/"                   \
                -e "s/NZ/$nz/"                   \
                -e "s/RADIUS/$radius/"           \
                -e "s/CX/$cx/"                   \
                -e "s/CY/$cy/"                   \
                -e "s/CZ/$cz/"                   \
                -e "s/INT/$int/"                 \
                -e "s/PRAD/$prad/"               \
                -e "s/PCENTX/$pcentx/"           \
                -e "s/PCENTY/$pcenty/"           \
                -e "s/PCENTZ/$pcentz/"           \
                -e "s/PPERT/$ppert/"             \
                -e "s/PFREQ/$pfreq/"             \
                -e "s/SINGX/$lsingxall[$singx]/" \
                -e "s/SINGY/$lsingyall[$singy]/" \
                -e "s/SINGZ/$lsingzall[$singz]/" \
                -e "s/EBBC/$ebbc/"               \
                -e "s/DOMBC/$dombc/"             \
                -e "s/NUMX/$size/"               \
                -e "s/NUMY/$size/"               \
                -e "s/NUMZ/$size/"               \
                < runone.proto > runone.$dim.inputs
            multigridTest$dim.Linux.g++.g77.ex runone.$dim.inputs \
              > runone.$dim.output
            grep '(final)' runone.$dim.output \
              >> $dir/runone.$dim.$name.${singx}${singy}${singz}.raw
            set zsize=`echo $size | awk '{printf("%04d",$1);}'`
            mv error.hdf5 $dir/error.$dim.$name.${singx}${singy}${singz}.$zsize.hdf5
            (gzip -f $dir/error.$dim.$name.${singx}${singy}${singz}.$zsize.hdf5 &) >&! /dev/null
          endif
          @ singz++
        end
      endif
      @ singy++
    end
    @ singx++
  end
  echo ""
  set size=`expr $size \* 2`
end
