#!/bin/csh -f
#
# Run one set of tests
#
set start=0
set sizemin=32
if ($?sizemax == 0) then
  if ($dim == "2d") then
    set sizemax=1024
  else
    set sizemax=128
  endif
endif
set size=$sizemin
set lfreqxall=($freqxall)
set lfreqyall=($freqyall)
set lfreqzall=($freqzall)
set freqxmax=$#lfreqxall
set freqymax=$#lfreqyall
set freqzmax=$#lfreqzall
while ($size <= $sizemax)
  echo "Size: $size"
  set freqx=1
  while ($freqx <= $freqxmax)
    set freqy=1
    while ($freqy <= $freqymax)
      if ($dim == "2d") then
        if ($size == $ssize && $freqx == $sfreqx && $freqy == $sfreqy) then
          set start=1
        endif
        if ($start == 1) then
          set freqz=1
          if ($size == $sizemin) then
            /bin/rm -f $dir/runone.$dim.$name.${freqx}${freqy}.raw
          endif
          echo "  Frequency: $lfreqxall[$freqx] $lfreqyall[$freqy]"
          sed -e "s/GEOM/$geom/"               \
              -e "s/CYCLE/$cycle/"             \
              -e "s/PX/$px/"                   \
              -e "s/PY/$py/"                   \
              -e "s/PZ/$pz/"                   \
              -e "s/NX/$nx/"                   \
              -e "s/NY/$ny/"                   \
              -e "s/NZ/$nz/"                   \
              -e "s/RADIUS/$radius/"           \
              -e "s/CX/$cx/"                   \
              -e "s/CY/$cy/"                   \
              -e "s/CZ/$cz/"                   \
              -e "s/INT/$int/"                 \
              -e "s/PRAD/$prad/"               \
              -e "s/PCENTX/$pcentx/"           \
              -e "s/PCENTY/$pcenty/"           \
              -e "s/PCENTZ/$pcentz/"           \
              -e "s/PPERT/$ppert/"             \
              -e "s/PFREQ/$pfreq/"             \
              -e "s/FREQX/$lfreqxall[$freqx]/" \
              -e "s/FREQY/$lfreqyall[$freqy]/" \
              -e "s/FREQZ/$lfreqzall[$freqz]/" \
              -e "s/EBBC/$ebbc/"               \
              -e "s/DOMBC/$dombc/"             \
              -e "s/PROBLO/$problo/"           \
              -e "s/PROBHI/$probhi/"           \
              -e "s/NUMX/$size/"               \
              -e "s/NUMY/$size/"               \
              -e "s/NUMZ/$size/"               \
              < runone.proto > runone.$dim.inputs
          multigridTest$dim.Linux.g++.g77.ex runone.$dim.inputs \
            > runone.$dim.output
          grep '(final)' runone.$dim.output \
            >> $dir/runone.$dim.$name.${freqx}${freqy}.raw
          set zsize=`echo $size | awk '{printf("%04d",$1);}'`
          mv error.hdf5 $dir/error.$dim.$name.${freqx}${freqy}.$zsize.hdf5
          (gzip -f $dir/error.$dim.$name.${freqx}${freqy}.$zsize.hdf5 &) >&! /dev/null
        endif
      else
        set freqz=1
        while ($freqz <= $freqzmax)
          if ($size == $ssize && $freqx == $sfreqx && $freqy == $sfreqy && $freqz == $sfreqz) then
            set start=1
          endif
          if ($start == 1) then
            if ($size == $sizemin) then
              /bin/rm -f $dir/runone.$dim.$name.${freqx}${freqy}${freqz}.raw
            endif
            echo "  Frequency: $lfreqxall[$freqx] $lfreqyall[$freqy] $lfreqzall[$freqz]"
            sed -e "s/GEOM/$geom/"               \
                -e "s/CYCLE/$cycle/"             \
                -e "s/PX/$px/"                   \
                -e "s/PY/$py/"                   \
                -e "s/PZ/$pz/"                   \
                -e "s/NX/$nx/"                   \
                -e "s/NY/$ny/"                   \
                -e "s/NZ/$nz/"                   \
                -e "s/RADIUS/$radius/"           \
                -e "s/CX/$cx/"                   \
                -e "s/CY/$cy/"                   \
                -e "s/CZ/$cz/"                   \
                -e "s/INT/$int/"                 \
                -e "s/PRAD/$prad/"               \
                -e "s/PCENTX/$pcentx/"           \
                -e "s/PCENTY/$pcenty/"           \
                -e "s/PCENTZ/$pcentz/"           \
                -e "s/PPERT/$ppert/"             \
                -e "s/PFREQ/$pfreq/"             \
                -e "s/FREQX/$lfreqxall[$freqx]/" \
                -e "s/FREQY/$lfreqyall[$freqy]/" \
                -e "s/FREQZ/$lfreqzall[$freqz]/" \
                -e "s/EBBC/$ebbc/"               \
                -e "s/DOMBC/$dombc/"             \
                -e "s/PROBLO/$problo/"           \
                -e "s/PROBHI/$probhi/"           \
                -e "s/NUMX/$size/"               \
                -e "s/NUMY/$size/"               \
                -e "s/NUMZ/$size/"               \
                < runone.proto > runone.$dim.inputs
            multigridTest$dim.Linux.g++.g77.ex runone.$dim.inputs \
              > runone.$dim.output
            grep '(final)' runone.$dim.output \
              >> $dir/runone.$dim.$name.${freqx}${freqy}${freqz}.raw
            set zsize=`echo $size | awk '{printf("%04d",$1);}'`
            mv error.hdf5 $dir/error.$dim.$name.${freqx}${freqy}${freqz}.$zsize.hdf5
            (gzip -f $dir/error.$dim.$name.${freqx}${freqy}${freqz}.$zsize.hdf5 &) >&! /dev/null
          endif
          @ freqz++
        end
      endif
      @ freqy++
    end
    @ freqx++
  end
  echo ""
  set size=`expr $size \* 2`
end
