#!/bin/csh -f
#
# Run one set of tests
#
set start=0
set sizemin=40
if ($?sizemax == 0) then
  if ($dim == "2d") then
    set sizemax=1280
  else
    set sizemax=320
  endif
endif
set size=$sizemin
set lexpoall=($expoall)
set lfreqall=($freqall)
set expomax=$#lexpoall
set freqmax=$#lfreqall
while ($size <= $sizemax)
  echo "Size: $size"
  set expo=1
  while ($expo <= $expomax)
    set freq=1
    while ($freq <= $freqmax)
      if ($dim == "2d") then
        if ($size == $ssize && $expo == $sexpo && $freq == $sfreq) then
          set start=1
        endif
        if ($start == 1) then
          if ($size == $sizemin) then
            /bin/rm -f $dir/runone.$dim.$name.${expo}${freq}.raw
          endif
          echo "  Params: $lexpoall[$expo] $lfreqall[$freq]"
          sed -e "s/GEOM/$geom/"             \
              -e "s/INT/$int/"               \
              -e "s/PRAD/$prad/"             \
              -e "s/PCENTX/$pcentx/"         \
              -e "s/PCENTY/$pcenty/"         \
              -e "s/PCENTZ/$pcentz/"         \
              -e "s/PPERT/$ppert/"           \
              -e "s/PFREQ/$pfreq/"           \
              -e "s/JEXPO/$lexpoall[$expo]/" \
              -e "s/JFREQ/$lfreqall[$freq]/" \
              -e "s/EBBC/$ebbc/"             \
              -e "s/DOMBC/$dombc/"           \
              -e "s/NUMX/$size/"             \
              -e "s/NUMY/$size/"             \
              -e "s/NUMZ/$size/"             \
              < runone.proto > runone.$dim.inputs
          truncTest$dim.Linux.g++.g77.ex runone.$dim.inputs \
            > runone.$dim.output
          head -1 runone.$dim.output \
            >> $dir/runone.$dim.$name.${expo}${freq}.raw
          set zsize=`echo $size | awk '{printf("%04d",$1);}'`
          mv error.hdf5 $dir/error.$dim.$name.${expo}${freq}.$zsize.hdf5
          (gzip -f $dir/error.$dim.$name.${expo}${freq}.$zsize.hdf5 &) >&! /dev/null
        endif
      else
        set z=1
        if ($size == $ssize && $expo == $sexpo && $freq == $sfreq) then
          set start=1
        endif
        if ($start == 1) then
          if ($size == $sizemin) then
            /bin/rm -f $dir/runone.$dim.$name.${expo}${freq}${z}.raw
          endif
          echo "  Params: $lexpoall[$expo] $lfreqall[$freq]"
          sed -e "s/GEOM/$geom/"             \
              -e "s/INT/$int/"               \
              -e "s/PRAD/$prad/"             \
              -e "s/PCENTX/$pcentx/"         \
              -e "s/PCENTY/$pcenty/"         \
              -e "s/PCENTZ/$pcentz/"         \
              -e "s/PPERT/$ppert/"           \
              -e "s/PFREQ/$pfreq/"           \
              -e "s/JEXPO/$lexpoall[$expo]/" \
              -e "s/JFREQ/$lfreqall[$freq]/" \
              -e "s/EBBC/$ebbc/"             \
              -e "s/DOMBC/$dombc/"           \
              -e "s/NUMX/$size/"             \
              -e "s/NUMY/$size/"             \
              -e "s/NUMZ/$size/"             \
              < runone.proto > runone.$dim.inputs
          truncTest$dim.Linux.g++.g77.ex runone.$dim.inputs \
            > runone.$dim.output
          head -1 runone.$dim.output \
            >> $dir/runone.$dim.$name.${expo}${freq}${z}.raw
          set zsize=`echo $size | awk '{printf("%04d",$1);}'`
          mv error.hdf5 $dir/error.$dim.$name.${expo}${freq}${z}.$zsize.hdf5
          (gzip -f $dir/error.$dim.$name.${expo}${freq}${z}.$zsize.hdf5 &) >&! /dev/null
        endif
      endif
      @ freq++
    end
    @ expo++
  end
  echo ""
  set size=`expr $size \* 2`
end
