#!/bin/csh -f
#
# Spatial dimension
#
setenv dimnum 2
if ($#argv >= 1) then
  if ("$1" == "-h") then
    echo "Usage:  runsome.csh [dim [dir [maxsize [startsize startexpo startfreq]]]]"
    exit
  else
    setenv dimnum ${1}
  endif
endif
setenv dim ${dimnum}d
#
# Directory for results
#
setenv dir results
if ($#argv >= 2) then
  setenv dir $2
endif
#
# Maximum size
#
if ($#argv >= 3) then
  setenv sizemax $3
endif
#
# Set starting size and frequency indices
#
setenv ssize 40
setenv sexpo 1
setenv sfreq 1
if ($#argv >= 4) then
  setenv ssize $4
  setenv sexpo $5
  setenv sfreq $6
endif
#
# Lists of exponents and frequencies
#
setenv expoall "4"
setenv freqall "3"
#
# Parameters for polar function (problem 1)
#
setenv pcentx  0.501
setenv pcenty  0.501
setenv pcentz  0.501
setenv prad    0.300
setenv ppert   0.150
setenv pfreq   6
#
# Interior of a polar function (problem 1a)
# Dirichlet domain BC, 1st order Dirichlet EB BC
#
setenv name  problem1a
setenv ebbc  1
setenv dombc 1
setenv geom  2
setenv int   1
runone.csh
#
# Interior of a polar function (problem 1b)
# Dirichlet domain BC, 2nd order Dirichlet EB BC
#
setenv name  problem1b
setenv ebbc  2
setenv dombc 1
setenv geom  2
setenv int   1
runone.csh
#
# Parameters for polar function (problem 3)
#
setenv pcentx  0.501
setenv pcenty  0.501
setenv pcentz  0.501
setenv prad    0.250
setenv ppert   0.050
setenv pfreq   6
#
# Exterior of a polar function (problem 3)
# Dirichlet domain BC, Neumann EB BC
#
setenv name  problem3
setenv ebbc  0
setenv dombc 1
setenv geom  2
setenv int   0
runone.csh
#
# Generate summaries
#
geterrors.csh $dir
getrates.csh  $dir
foreach name (problem1a problem1b problem3)
  getsummary.csh $name $dimnum $dir |& tee $dir/summary.$dim.$name
end
