#!/bin/csh -f
#
# Run one set of tests
#
set start=0
set sizemin=32
if ($?sizemax == 0) then
  if ($dim == "2d") then
    set sizemax=1024
  else
    set sizemax=256
  endif
endif
if ($?powmin == 0) then
  set powmin=0
endif
if ($?powmax == 0) then
  set powmax=4
endif
set size=$sizemin
while ($size <= $sizemax)
  echo "Size: $size"
  set powx=0
  while ($powx <= $powmax)
    set powy=0
    while ($powy <= $powmax)
      if ($dim == "2d") then
        if ($size == $ssize && $powx == $spowx && $powy == $spowy) then
          set start=1
        endif
        if ($start == 1 && ($powx >= $powmin || $powy >= $powmin)) then
          set powz=0
          if ($size == $sizemin) then
            /bin/rm -f $dir/runone.$dim.$name.${powx}${powy}.raw
          endif
          echo "  Power: $powx $powy"
          sed -e "s/GEOM/$geom/"     \
              -e "s/PX/$px/"         \
              -e "s/PY/$py/"         \
              -e "s/PZ/$pz/"         \
              -e "s/NX/$nx/"         \
              -e "s/NY/$ny/"         \
              -e "s/NZ/$nz/"         \
              -e "s/RADIUS/$radius/" \
              -e "s/CX/$cx/"         \
              -e "s/CY/$cy/"         \
              -e "s/CZ/$cz/"         \
              -e "s/INT/$int/"       \
              -e "s/PRAD/$prad/"     \
              -e "s/PCENTX/$pcentx/" \
              -e "s/PCENTY/$pcenty/" \
              -e "s/PCENTZ/$pcentz/" \
              -e "s/PPERT/$ppert/"   \
              -e "s/PFREQ/$pfreq/"   \
              -e "s/POWX/$powx/"     \
              -e "s/POWY/$powy/"     \
              -e "s/POWZ/$powz/"     \
              -e "s/EBBC/$ebbc/"     \
              -e "s/DOMBC/$dombc/"   \
              -e "s/NUMX/$size/"     \
              -e "s/NUMY/$size/"     \
              -e "s/NUMZ/$size/"     \
              < runone.proto > runone.$dim.inputs
          truncTest$dim.Linux.g++.g77.ex runone.$dim.inputs \
            > runone.$dim.output
          head -1 runone.$dim.output \
            >> $dir/runone.$dim.$name.${powx}${powy}.raw
          set zsize=`echo $size | awk '{printf("%04d",$1);}'`
          mv error.hdf5 $dir/error.$dim.$name.${powx}${powy}.$zsize.hdf5
          (gzip -f $dir/error.$dim.$name.${powx}${powy}.$zsize.hdf5 &) >&! /dev/null
        endif
      else
        set powz=0
        while ($powz <= $powmax)
          if ($size == $ssize && $powx == $spowx && $powy == $spowy && $powz == $spowz) then
            set start=1
          endif
          if ($start == 1 && ($powx >= $powmin || $powy >= $powmin || $powz >= $powmin)) then
            if ($size == $sizemin) then
              /bin/rm -f $dir/runone.$dim.$name.${powx}${powy}${powz}.raw
            endif
            echo "  Power: $powx $powy $powz"
            sed -e "s/GEOM/$geom/"     \
                -e "s/PX/$px/"         \
                -e "s/PY/$py/"         \
                -e "s/PZ/$pz/"         \
                -e "s/NX/$nx/"         \
                -e "s/NY/$ny/"         \
                -e "s/NZ/$nz/"         \
                -e "s/RADIUS/$radius/" \
                -e "s/CX/$cx/"         \
                -e "s/CY/$cy/"         \
                -e "s/CZ/$cz/"         \
                -e "s/INT/$int/"       \
                -e "s/PRAD/$prad/"     \
                -e "s/PCENTX/$pcentx/" \
                -e "s/PCENTY/$pcenty/" \
                -e "s/PCENTZ/$pcentz/" \
                -e "s/PPERT/$ppert/"   \
                -e "s/PFREQ/$pfreq/"   \
                -e "s/POWX/$powx/"     \
                -e "s/POWY/$powy/"     \
                -e "s/POWZ/$powz/"     \
                -e "s/EBBC/$ebbc/"     \
                -e "s/DOMBC/$dombc/"   \
                -e "s/NUMX/$size/"     \
                -e "s/NUMY/$size/"     \
                -e "s/NUMZ/$size/"     \
                < runone.proto > runone.$dim.inputs
            truncTest$dim.Linux.g++.g77.ex runone.$dim.inputs \
              > runone.$dim.output
            head -1 runone.$dim.output \
              >> $dir/runone.$dim.$name.${powx}${powy}${powz}.raw
            set zsize=`echo $size | awk '{printf("%04d",$1);}'`
            mv error.hdf5 $dir/error.$dim.$name.${powx}${powy}${powz}.$zsize.hdf5
            (gzip -f $dir/error.$dim.$name.${powx}${powy}${powz}.$zsize.hdf5 &) >&! /dev/null
          endif
          @ powz++
        end
      endif
      @ powy++
    end
    @ powx++
  end
  echo ""
  set size=`expr $size \* 2`
end
