#!/bin/csh -f
if ($#argv < 1) then
  echo "Usage:  getsummary.csh name [dim [dir]]"
  exit 1
endif
set name=$1
endif
set dim=2
if ($#argv >= 2) then
  set dim=$2
endif
set dir=results
if ($#argv >= 3) then
  set dir=$3
endif
set singxall=(-0.43 0.52 1.61)
set singyall=(-0.51 0.63 1.42)
set singzall=(-0.62 0.41 1.53)
echo ""
awk -f getsummary.title.awk dim="$dim" < /dev/null
foreach f (`ls $dir/runone.${dim}d.${name}.*.rate`)
  set root=$f:r
  set singular=$root:e
  set singx=`echo $singular | awk '{printf("%s",substr($1,1,1));}'`
  set singy=`echo $singular | awk '{printf("%s",substr($1,2,1));}'`
  if ($dim == 2) then
    set singz=0
  else
    set singz=`echo $singular | awk '{printf("%s",substr($1,3,1));}'`
  endif
  set printone=1
  if ($dim == 2) then
    echo "$singxall[$singx] $singyall[$singy]" | awk -f getsummary.singular.awk
    tail -1 $dir/runone.${dim}d.$name.${singx}${singy}.error > getsummary.temp
    tail -1 $dir/runone.${dim}d.$name.${singx}${singy}.rate >> getsummary.temp
    awk -f getsummary.results.awk < getsummary.temp
  else
    echo "$singxall[$singx] $singyall[$singy] $singzall[$singz]" | awk -f getsummary.singular.awk
    tail -1 $dir/runone.${dim}d.$name.${singx}${singy}${singz}.error > getsummary.temp
    tail -1 $dir/runone.${dim}d.$name.${singx}${singy}${singz}.rate >> getsummary.temp
    awk -f getsummary.results.awk < getsummary.temp
  endif
end
/bin/rm -f getsummary.temp
