/* _______              __
   / ___/ /  ___  __ _  / /  ___
   / /__/ _ \/ _ \/  ' \/ _ \/ _ \
   \___/_//_/\___/_/_/_/_.__/\___/
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
//
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//

#include "ConstVel.H"
#include "MayDay.H"
#include "PolyGeom.H"
/*****/
RealVect ConstVel::
getVel(const RealVect& a_xloc)
{
  RealVect crossVec = m_axis;
  crossVec *= m_constant;

  return crossVec;
}
/*****/
ConstVel::
ConstVel(const RealVect& a_axis, const Real& a_constant)
{
  m_axis     = a_axis;
  m_constant = a_constant;
}
/*****/
BaseVelocity* ConstVelFactory::
create() const
{
  ConstVel* retval = new ConstVel( m_axis, m_constant);
  return (BaseVelocity *)retval;  
}
/****/
ConstVelFactory:: 
ConstVelFactory(const RealVect& a_axis, const Real& a_constant)
{
  m_axis     = a_axis;
  m_constant = a_constant;
}
/****/
