
/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
//
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//


#ifndef _EBBumpIBCFACTORY_H
#define _EBBumpIBCFACTORY_H

#include "EBBumpIBC.H"
#include "EBCellFAB.H"
#include "EBFaceFAB.H"
#include "REAL.H"
#include "LevelData.H"
#include "ProblemDomain.H"
#include "EBPhysIBC.H"
#include "EBBumpIBC.H"
#include "EBPhysIBCFactory.H"

///
/**
 */
class EBBumpIBCFactory: public EBPhysIBCFactory
{
public:

  ///
  ~EBBumpIBCFactory();

  ///
  EBBumpIBCFactory(const RealVect& a_center,
                   const RealVect& a_axis,
                   const RealVect& a_vel,
                   const Real&     a_size,
                   const Real&     a_r0,
                   const Real&     a_r1);
                   

  ///
  EBPhysIBC* create() const;

protected:
  RealVect m_center;
  RealVect m_axis;
  RealVect m_vel;
  Real     m_size;
  Real     m_r0;
  Real     m_r1;

private:
  EBBumpIBCFactory()
  {
    MayDay::Error("Invalid operator");
  }
  
  void operator=(const EBBumpIBCFactory& a_input)
  {
    MayDay::Error("Invalid operator");
  }
  
  EBBumpIBCFactory(const EBBumpIBCFactory& a_input)
  {
    MayDay::Error("Invalid operator");
  }
  

};

#endif
