# -*- Mode: Makefile; Modified: "Mon 29 Mar 2004 15:41:55 by dbs"; -*- 

### This is a compiler-specific definitions file for the HP Tru64 C++ compiler "cxx"
## It documents all the compiler variables.

## The important things to know:
##  1) this file should _only_ set variables that begin with "def".
##  2) the $cxxname and $fname variables should be used to determine
##     the names of the C++ and Fortran compilers, since $CXX and $FC.
##     may contain a directory path and/or options.
##  3) The 'Make.defs' file automatically merges the $def* variables into
##     the variables actually used in the make rules that compile/link code.
##  4) The user can override any of these variables on the command line.
##  5) The $cxx*flags variables (except for $cxxcppflags) are also used in
##     the link rule, so any option that is the same for the linker and
##     compiler should not be repeated in the $ld*flags variables.

## Compiler Variables:
##  defcppdbgflags = C-preprocessor options for both C++ and Fortran code when DEBUG=TRUE
##  defcppoptflags = C-preprocessor options for both C++ and Fortran code when DEBUG=FALSE
##  defcxxcppflags = C-preprocessor options for only C++ code
##  defcxxdbgflags = C++ compiler/linker options when DEBUG=TRUE
##  defcxxoptflags = C++ compiler/linker options when DEBUG=FALSE
##  defcxxprofflags= C++ compiler/linker options when PROFILE=TRUE
##  deffcppflags   = C-preprocessor options for only Fortran code
##  deffdbgflags   = Fortran compiler options when DEBUG=TRUE
##  deffoptflags   = Fortran compiler options when DEBUG=FALSE
##  deffprofflags  = Fortran compiler options when PROFILE=TRUE
##  defflibflags   = linker options to specify the Fortran libraries
##  deflddbgflags  = linker options when DEBUG=TRUE
##  defldoptflags  = linker options when DEBUG=FALSE
##  defldprofflags = linker options when PROFILE=TRUE
##  cppcallsfort   = preprocessor macro as used in FORT_PROTO.H to specify
##                    how the C++ code should construct names for calling Fortran

makefiles+=compiler/Make.defs.cxx

cxxname := $(notdir $(firstword $(CXX)))
fname   := $(notdir $(firstword $(FC)))

ifeq ($(cxxname),cxx)
  defcxxcppflags = -D__USE_STD_IOSTREAM
  defcxxdbgflags = -g -std gnu
  defcxxoptflags = -fast -std gnu
  #[NOTE: these may be needed on some versions of cxx, but not v6.5 on OSF1 v5.1]
  #deflddbgflags = -Wl,-S
  #defldoptflags = -Wl,-S
  syslibflags   = -lm
  CPP = $(CXX) -E -x c++
endif
