/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
//  ANAG, LBNL
/***************/
/***************/
template <class T> inline 
BaseIFFactory<T>::~BaseIFFactory()
{
}
/***************/
/***************/
template <class T> inline 
BaseIFFactory<T>::BaseIFFactory(const EBISLayout& a_ebisl,
                                const LayoutData<IntVectSet>& a_sets,
                                const int& a_facedir)
{
  m_ebisl = a_ebisl;
  m_facedir = a_facedir;
  m_sets.define(a_sets.boxLayout());
  for(DataIterator dit = m_sets.dataIterator(); dit.ok(); ++dit)
    {
      m_sets[dit()] = a_sets[dit()];
    }
}
/***************/
/***************/
template <class T> inline 
BaseIFFAB<T>*
BaseIFFactory<T>::create(const Box& a_box, int a_ncomps, 
                         const DataIndex& a_dit) const
{
  //intersects with input box because leveldata will expect
  //that anyway when it tries to do a copy or a linearization.
  IntVectSet ivsInter = m_sets[a_dit];
  ivsInter &= a_box;
  return new BaseIFFAB<T>(ivsInter, m_ebisl[a_dit].getEBGraph(), m_facedir, a_ncomps);
}
/***************/
/***************/
