/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
//  ANAG, LBNL, DTG

#ifndef _EBGraphFactory_H_
#define _EBGraphFactory_H_

#include "Box.H"
#include "BoxLayoutData.H"
#include "EBGraph.H"

/// Factory class to produce EBGraph(es)
/**
   This is needed for LevelData construction.
 */
class EBGraphFactory
  : public DataFactory<EBGraph>
{
public:
  /// 
  /** 
      Creates an undefined EBGraph.  
  */
  virtual EBGraph* create(const Box& a_box, int a_ncomps, 
                          const DataIndex& a_datInd) const;

  ///
  /**
   */
  EBGraphFactory(const Box& a_domain);

  ///
  /**
   */
  virtual ~EBGraphFactory();

private:
  EBGraphFactory()
  {
    MayDay::Error("ebisboxfactory uses strong construction");
  }
  Box m_domain;
};
#endif
