/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
#include "EBLoadBalance.H"
#include "EBIndexSpace.H"
#include "EBISLayout.H"
#include "EBISBox.H"
#include "LoadBalance.H"
#include "SPMD.H"

int 
EBLoadBalance(Vector<int>&       a_procs, 
              Vector<Box>&       a_outBoxes,
              Real&              a_effRatio,
              const Vector<Box>& a_inBoxes, 
              const Box&         a_domain,
              long  coveredLoad,
              long  irregFactor)
{
  //first load balance the conventional way.
  Vector<int> origProcs;
  int retval=LoadBalance(origProcs, a_inBoxes);
  a_procs = origProcs; 
  a_outBoxes = a_inBoxes;
  a_effRatio = -1.0;
//if(numProc() > 1)
//  {
//    const EBIndexSpace* const ebisPtr = Chombo_EBIS::instance();
//    int nghost = 0;
//    DisjointBoxLayout dblOrig(a_inBoxes, origProcs);
//    EBISLayout ebisl;
//    ebisPtr->fillEBISLayout(ebisl, dblOrig, a_domain, nghost);
//
//    Vector<Box>  boxesLocal;
//    Vector<long> loadsLocal;
//    for(DataIterator dit = dblOrig.dataIterator(); dit.ok(); ++dit)
//      {
//        const Box& box = dblOrig.get(dit());
//        const EBISBox& ebisBox = ebisl[dit()];
//        long npts = box.numPts();
//        long boxload;
//        if(ebisBox.isAllRegular())
//          {
//            boxload = npts;
//          }
//        else if(ebisBox.isAllCovered())
//          {
//            
//            boxload = coveredLoad;
//          }
//        else
//          {
//            IntVectSet ivsIrreg = ebisBox.getIrregIVS(box);
//            Vector<Box> ivsBoxes = ivsIrreg.boxes();
//            long irregLoad = 0;
//            for(int ibox = 0; ibox < ivsBoxes.size(); ibox++)
//              {
//                irregLoad += ivsBoxes[ibox].numPts();
//              }
//            irregLoad *= irregFactor;
//            boxload = irregLoad + npts;
//          }
//        boxesLocal.push_back(box);
//        loadsLocal.push_back(boxload);
//        Vector<Vector<Box> >   allBoxes;
//        Vector<Vector<long> >  allLoads;
//        gather(allBoxes, boxesLocal, uniqueProc(SerialTask::compute));
//        gather(allLoads, loadsLocal, uniqueProc(SerialTask::compute));
//        Vector<long> loads;
//        a_outBoxes.resize(0);
//        if (procID() == uniqueProc(SerialTask::compute))
//          {
//            assert(allBoxes.size() == allLoads.size());
//            for(int iproc = 0; iproc < allBoxes.size(); iproc++)
//              {
//                loads.append(allLoads[iproc]);
//                a_outBoxes.append(allBoxes[iproc]);
//              }
//          }
//
//        broadcast(a_outBoxes, uniqueProc(SerialTask::compute));
//        broadcast(loads,      uniqueProc(SerialTask::compute));
//        LoadBalance(a_procs, a_effRatio, a_outBoxes, loads);
//      }
//  }
  return retval;
}

