/*
   __  ______________              __      
  /  |/  / __/ ___/ /  ___  __ _  / /  ___ 
 / /|_/ / _// /__/ _ \/ _ \/  ' \/ _ \/ _ \
/_/  /_/_/  \___/_//_/\___/_/_/_/_.__/\___/
                                           
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//


#ifndef _MFALIASFACTORY_H_
#define _MFALIASFACTORY_H_

#include "EBCellFAB.H"
#include "BoxLayoutData.H"
#include "MFCellFAB.H"

class MFAliasFactory : public DataFactory<EBCellFAB>
{
public:
  /// factory function.  creates a new 'T' object
  /** creates a new 'T' object and returns a pointer to it. 
   */
  virtual EBCellFAB* create(const Box& box, int ncomps, const DataIndex& a_datInd) const;

  virtual bool callDelete() const {return false;}

  MFAliasFactory(LevelData<MFCellFAB>* a_mf,
                 int a_phase);

private:
  
  LevelData<MFCellFAB>* m_mf;
  int m_phase;
};


void aliasMF(Vector<LevelData<EBCellFAB>* >& a_phases, int a_numPhases,
             const LevelData<MFCellFAB>& a_input);

void aliasMF(LevelData<EBCellFAB>& alias,  int phase, 
             const LevelData<MFCellFAB>& a_input);

void aliasMF(Vector<LevelData<EBCellFAB>* >& a_output, int whichPhase,
             const Vector<LevelData<MFCellFAB>* >& a_input);

#endif

