      subroutine SETBENCHMARK(
     & augamma
     & ,auenergy
     & ,aurho0
     & ,aup0
     & ,aucenter
     & ,ausize
     & ,auvelocity
     & ,auartvisc
     & )
      implicit none
      REAL*8 augamma
      REAL*8 auenergy
      REAL*8 aurho0
      REAL*8 aup0
      REAL*8 aucenter(0:2)
      REAL*8 ausize
      REAL*8 auvelocity(0:2)
      REAL*8 auartvisc









        REAL*8 energy, rho0, p0
        REAL*8 centerx,centery,centerz
        REAL*8 size
        REAL*8 velx,vely,velz
        REAL*8 artvisc
        common /explosioncm/
     & energy, rho0, p0,
     & centerx,centery,centerz,
     & size,
     & velx,vely,velz,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        REAL*8 p,umag, e, vol
        gamma = augamma
        energy = auenergy
        rho0 = aurho0
        p0 = aup0
        centerx = aucenter(0)
        centery = aucenter(1)
        centerz = aucenter(2)
        size = ausize
        velx = auvelocity(0)
        vely = auvelocity(1)
        velz = auvelocity(2)
        artvisc = auartvisc
        vol = (3.14159265358979323846264338327950288d0)*size*size*(4.0d0
     &)*size/(3.0d0)
        e = energy/vol
        p = ((gamma + 1)*e + (1.0d0))*p0
        smallr = small*rho0
        smallu = small*umag
        smallp = small*p
        return
        end
      subroutine BENCHMARKINIT(
     & U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,sumScaledEnergy
     & ,dx
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      REAL*8 sumScaledEnergy
      REAL*8 dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        REAL*8 ke, p,r, e, e0, vol
        REAL*8 uu,vv,ww
        integer i,j,k
        REAL*8 x,y,z
        REAL*8 xcenter,ycenter,zcenter
        REAL*8 rad0sqr,radsqr, cellVol









        REAL*8 energy, rho0, p0
        REAL*8 centerx,centery,centerz
        REAL*8 size
        REAL*8 velx,vely,velz
        REAL*8 artvisc
        common /explosioncm/
     & energy, rho0, p0,
     & centerx,centery,centerz,
     & size,
     & velx,vely,velz,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        xcenter = centerx
        ycenter = centery
        zcenter = centerz
        rad0sqr = size*size
        uu = velx
        vv = vely
        ww = velz
        ke = (0.500d0)*(uu*uu + vv*vv + ww*ww)
        vol = (3.14159265358979323846264338327950288d0)*size*size*(4.0d0
     &)*size/(3.0d0)
        cellVol = dx*dx*dx
        e = energy/vol
        e0 = p0/(gamma - (1.0d0)) + rho0*ke
        p = (gamma-1)*e + p0
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          x = (i + (0.500d0))*dx - xcenter
          y = (j + (0.500d0))*dx - ycenter
          z = (k + (0.500d0))*dx - zcenter
          radsqr = x*x + y*y + z*z
          if (radsqr .ge. rad0sqr) then
            U(i,j,k,0) = rho0
            U(i,j,k,1) = uu*rho0
            U(i,j,k,2) = vv*rho0
            U(i,j,k,3) = ww*rho0
            U(i,j,k,4) = e0
          else
            U(i,j,k,0) = rho0
            U(i,j,k,1) = uu*r
            U(i,j,k,2) = vv*r
            U(i,j,k,3) = ww*r
            U(i,j,k,4) = e + e0
            sumScaledEnergy = sumScaledEnergy + e*cellVol/energy
          endif
      enddo
      enddo
      enddo
        return
        end
      subroutine BENCHMARKINITCORRECT(
     & U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,scaling
     & ,sumScaledEnergy
     & ,dx
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      REAL*8 scaling
      REAL*8 sumScaledEnergy
      REAL*8 dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        REAL*8 ke,p, e, e0, vol
        REAL*8 uu,vv,ww
        integer i,j,k
        REAL*8 x,y,z
        REAL*8 xcenter,ycenter,zcenter
        REAL*8 rad0sqr,radsqr, cellVol









        REAL*8 energy, rho0, p0
        REAL*8 centerx,centery,centerz
        REAL*8 size
        REAL*8 velx,vely,velz
        REAL*8 artvisc
        common /explosioncm/
     & energy, rho0, p0,
     & centerx,centery,centerz,
     & size,
     & velx,vely,velz,
     & artvisc



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        xcenter = centerx
        ycenter = centery
        zcenter = centerz
        rad0sqr = size*size
        uu = velx
        vv = vely
        ww = velz
        ke = (0.500d0)*(uu*uu + vv*vv + ww*ww)
        vol = (3.14159265358979323846264338327950288d0)*size*size*(4.0d0
     &)*size/(3.0d0)
        cellVol = dx*dx*dx
        e = scaling*energy/vol
        e0 = p0/(gamma - (1.0d0)) + rho0*ke
        p = (gamma-1)*e + p0
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          x = (i + (0.500d0))*dx - xcenter
          y = (j + (0.500d0))*dx - ycenter
          z = (k + (0.500d0))*dx - zcenter
          radsqr = x*x + y*y + z*z
          if (radsqr .lt. rad0sqr) then
            U(i,j,k,4) = e + e0
            sumScaledEnergy = sumScaledEnergy + e*cellVol/energy
          endif
      enddo
      enddo
      enddo
        return
        end
