      subroutine MAXWAVESPEED(
     & cmax
     & ,cons
     & ,iconslo0,iconslo1,iconslo2
     & ,iconshi0,iconshi1,iconshi2
     & ,nconscomp
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      REAL*8 cmax
      integer nconscomp
      integer iconslo0,iconslo1,iconslo2
      integer iconshi0,iconshi1,iconshi2
      REAL*8 cons(
     & iconslo0:iconshi0,
     & iconslo1:iconshi1,
     & iconslo2:iconshi2,
     & 0:nconscomp-1)
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i,j,k
        REAL*8 u,v,w
        REAL*8 umax,cspeed,ke,re,rho,invrho



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        cmax = (0.0d0)
        umax = (0.0d0)
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          rho = cons(i,j,k,0)
          invrho = (1.0d0)/rho
          u = cons(i,j,k,1)*invrho
          v = cons(i,j,k,2)*invrho
          w = cons(i,j,k,3)*invrho
          ke = (0.500d0)*(u*u + v*v + w*w)
          re = cons(i,j,k,4) - ke*rho
          cspeed = sqrt(gamma*re*(gamma - (1.0d0))*invrho)
          umax = max(abs(u),umax)
          umax = max(abs(v),umax)
          umax = max(abs(w),umax)
          cmax = max(umax + cspeed,cmax)
      enddo
      enddo
      enddo
        return
        end
      subroutine CONSTOPRIM(
     & W
     & ,iWlo0,iWlo1,iWlo2
     & ,iWhi0,iWhi1,iWhi2
     & ,nWcomp
     & ,U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL*8 W(
     & iWlo0:iWhi0,
     & iWlo1:iWhi1,
     & iWlo2:iWhi2,
     & 0:nWcomp-1)
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i,j,k
        REAL*8 uu,vv,ww
        REAL*8 rho,p,re,ke



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          rho = U(i,j,k,0)
          uu = U(i,j,k,1)/rho
          vv = U(i,j,k,2)/rho
          ww = U(i,j,k,3)/rho
          ke = (0.500d0)*(uu*uu + vv*vv + ww*ww)
          re = U(i,j,k,4) - rho*ke
          p = (gamma - (1.0d0))*re
          p = max(p,smallp)
          W(i,j,k,1) = uu
          W(i,j,k,2) = vv
          W(i,j,k,3) = ww
          W(i,j,k,0) = rho
          W(i,j,k,4) = p
      enddo
      enddo
      enddo
        return
        end
      subroutine PRIMTOCONS(
     & U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,W
     & ,iWlo0,iWlo1,iWlo2
     & ,iWhi0,iWhi1,iWhi2
     & ,nWcomp
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL*8 W(
     & iWlo0:iWhi0,
     & iWlo1:iWhi1,
     & iWlo2:iWhi2,
     & 0:nWcomp-1)
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i ,j ,k
        REAL*8 uu,vv,ww
        REAL*8 p,rho,ke



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
      do K = iboxlo2,iboxhi2
      do J = iboxlo1,iboxhi1
      do I = iboxlo0,iboxhi0
          rho = max(W(i,j,k,0),smallr)
          uu = W(i,j,k,1)
          vv = W(i,j,k,2)
          ww = W(i,j,k,3)
          ke = (0.500d0) * (uu*uu + vv*vv + ww*ww)
          p = W(i,j,k,4)
          U(i,j,k,0) = rho
          U(i,j,k,1) = rho*uu
          U(i,j,k,2) = rho*vv
          U(i,j,k,3) = rho*ww
          U(i,j,k,4) = rho*ke + p/(gamma - (1.0d0))
      enddo
      enddo
      enddo
        return
        end
      subroutine NORMALPRED(
     & WMinus
     & ,iWMinuslo0,iWMinuslo1,iWMinuslo2
     & ,iWMinushi0,iWMinushi1,iWMinushi2
     & ,nWMinuscomp
     & ,WPlus
     & ,iWPluslo0,iWPluslo1,iWPluslo2
     & ,iWPlushi0,iWPlushi1,iWPlushi2
     & ,nWPluscomp
     & ,W
     & ,iWlo0,iWlo1,iWlo2
     & ,iWhi0,iWhi1,iWhi2
     & ,nWcomp
     & ,dW
     & ,idWlo0,idWlo1,idWlo2
     & ,idWhi0,idWhi1,idWhi2
     & ,ndWcomp
     & ,dtbydx
     & ,normdir
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer nWMinuscomp
      integer iWMinuslo0,iWMinuslo1,iWMinuslo2
      integer iWMinushi0,iWMinushi1,iWMinushi2
      REAL*8 WMinus(
     & iWMinuslo0:iWMinushi0,
     & iWMinuslo1:iWMinushi1,
     & iWMinuslo2:iWMinushi2,
     & 0:nWMinuscomp-1)
      integer nWPluscomp
      integer iWPluslo0,iWPluslo1,iWPluslo2
      integer iWPlushi0,iWPlushi1,iWPlushi2
      REAL*8 WPlus(
     & iWPluslo0:iWPlushi0,
     & iWPluslo1:iWPlushi1,
     & iWPluslo2:iWPlushi2,
     & 0:nWPluscomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL*8 W(
     & iWlo0:iWhi0,
     & iWlo1:iWhi1,
     & iWlo2:iWhi2,
     & 0:nWcomp-1)
      integer ndWcomp
      integer idWlo0,idWlo1,idWlo2
      integer idWhi0,idWhi1,idWhi2
      REAL*8 dW(
     & idWlo0:idWhi0,
     & idWlo1:idWhi1,
     & idWlo2:idWhi2,
     & 0:ndWcomp-1)
      REAL*8 dtbydx
      integer normdir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer inorm,itan1,itan2
        integer i,j,k
        integer ioff,joff,koff
        REAL*8 p,rho,dp,drho,c,upc,umc
        REAL*8 alphap,alpham
        REAL*8 alpha0r,alpha0v1,alpha0v2
        REAL*8 betam,beta0,betap
        integer spacedim
        REAL*8 un,ut1,ut2
        REAL*8 dun,dut1,dut2



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        spacedim = 3
        ioff = CHF_ID(0,normdir)
        joff = CHF_ID(1,normdir)
        koff = CHF_ID(2,normdir)
        inorm = 1 + normdir
        itan1 = 1 + mod(normdir + 1,spacedim)
        itan2 = 1 + mod(normdir + 2,spacedim)
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          p = max(smallp,W(i,j,k,4))
          rho = max(smallr,W(i,j,k,0))
          un = W(i,j,k,inorm)
          ut1 = W(i,j,k,itan1)
          ut2 = W(i,j,k,itan2)
          dp = dW(i,j,k,4)
          drho = dW(i,j,k,0)
          dun = dW(i,j,k,inorm)
          dut1 = dW(i,j,k,itan1)
          dut2 = dW(i,j,k,itan2)
          c = sqrt(gamma*p/rho)
          upc = un + c
          umc = un - c
          alphap = (0.500d0)*( rho*dun/c + dp/c**2)
          alpham = (0.500d0)*(-rho*dun/c + dp/c**2)
          alpha0r = drho - dp/c**2
          alpha0v1 = dut1
          alpha0v2 = dut2
          betam = -(0.500d0)*((1.0d0) + min(umc,(0.0d0))*dtbydx)
          beta0 = -(0.500d0)* c *dtbydx
          if (un.ge.(0.0d0)) beta0 = (0.0d0)
          betap = -c*dtbydx
          if (upc.ge.(0.0d0)) betap = (0.0d0)
          WMinus(i,j,k,0) = alpha0r*beta0 + alphap*betap
     & + W(i,j,k,0) + betam*drho
          WMinus(i,j,k,inorm) = alphap*betap*c/rho
     & + W(i,j,k,inorm) + betam*dun
          WMinus(i,j,k,itan1) = alpha0v1*beta0
     & + W(i,j,k,itan1) + betam*dut1
          WMinus(i,j,k,itan2) = alpha0v2*beta0
     & + W(i,j,k,itan2) + betam*dut2
          WMinus(i,j,k,4) = alphap*betap*c**2
     & + W(i,j,k,4) + betam*dp
          betap = (0.500d0)*((1.0d0) - max(upc,(0.0d0))*dtbydx)
          beta0 = (0.500d0)* c *dtbydx
          if (un.le.(0.0d0)) beta0 = (0.0d0)
          betam = c*dtbydx
          if (umc.le.(0.0d0)) betam = (0.0d0)
          WPlus(i,j,k,0) = alpha0r*beta0 + alpham*betam
     & + W(i,j,k,0) + betap*drho
          WPlus(i,j,k,inorm) = -alpham*betam*c/rho
     & + W(i,j,k,inorm) + betap*dun
          WPlus(i,j,k,itan1) = alpha0v1*beta0
     & + W(i,j,k,itan1) + betap*dut1
          WPlus(i,j,k,itan2) = alpha0v2*beta0
     & + W(i,j,k,itan2) + betap*dut2
          WPlus(i,j,k,4) = alpham*betam*c**2
     & + W(i,j,k,4) + betap*dp
          WPlus(i,j,k,4) = max(WPlus(i,j,k,4),smallp)
          WPlus(i,j,k,0) = max(WPlus(i,j,k,0 ),smallr)
          WMinus(i,j,k,4) = max(WMinus(i,j,k,4),smallp)
          WMinus(i,j,k,0) = max(WMinus(i,j,k,0 ),smallr)
      enddo
      enddo
      enddo
        return
        end
      subroutine RIEMANNF(
     & Wgdnv
     & ,iWgdnvlo0,iWgdnvlo1,iWgdnvlo2
     & ,iWgdnvhi0,iWgdnvhi1,iWgdnvhi2
     & ,nWgdnvcomp
     & ,WLeft
     & ,iWLeftlo0,iWLeftlo1,iWLeftlo2
     & ,iWLefthi0,iWLefthi1,iWLefthi2
     & ,nWLeftcomp
     & ,WRight
     & ,iWRightlo0,iWRightlo1,iWRightlo2
     & ,iWRighthi0,iWRighthi1,iWRighthi2
     & ,nWRightcomp
     & ,idir
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nWgdnvcomp
      integer iWgdnvlo0,iWgdnvlo1,iWgdnvlo2
      integer iWgdnvhi0,iWgdnvhi1,iWgdnvhi2
      REAL*8 Wgdnv(
     & iWgdnvlo0:iWgdnvhi0,
     & iWgdnvlo1:iWgdnvhi1,
     & iWgdnvlo2:iWgdnvhi2,
     & 0:nWgdnvcomp-1)
      integer nWLeftcomp
      integer iWLeftlo0,iWLeftlo1,iWLeftlo2
      integer iWLefthi0,iWLefthi1,iWLefthi2
      REAL*8 WLeft(
     & iWLeftlo0:iWLefthi0,
     & iWLeftlo1:iWLefthi1,
     & iWLeftlo2:iWLefthi2,
     & 0:nWLeftcomp-1)
      integer nWRightcomp
      integer iWRightlo0,iWRightlo1,iWRightlo2
      integer iWRighthi0,iWRighthi1,iWRighthi2
      REAL*8 WRight(
     & iWRightlo0:iWRighthi0,
     & iWRightlo1:iWRighthi1,
     & iWRightlo2:iWRighthi2,
     & 0:nWRightcomp-1)
      integer idir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i, j, k
        integer inorm, itan1, itan2
        REAL*8 pl,rhol,pr,rhor,cl,cr,wl,wr,wstar
        REAL*8 pstar,ustar,ro,po,uno,co,sgnm
        REAL*8 rstar,cstar,spout,spin,ushock,frac
        REAL*8 unl,unr
        integer spacedim



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        spacedim = 3
        inorm = 1 + idir
        itan1 = 1 + mod(idir + 1,spacedim)
        itan2 = 1 + mod(idir + 2,spacedim)
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          pl = max(smallp,WLeft(i,j,k,4))
          rhol = max(smallr,WLeft(i,j,k,0))
          unl = WLeft(i,j,k,inorm)
          pr = max(smallp,WRight(i,j,k,4))
          rhor = max(smallr,WRight(i,j,k,0) )
          unr = WRight(i,j,k,inorm)
          cl = sqrt(gamma*pl/rhol)
          cr = sqrt(gamma*pr/rhor)
          wl = rhol*cl
          wr = rhor*cr
          pstar = (wr*pl + wl*pr + wl*wr*(unl - unr))/(wl + wr)
          ustar = (wl*unl + wr*unr + pl - pr)/(wl + wr)
          if (ustar .gt. (0.0d0)) then
            ro = rhol
            po = pl
            uno = unl
            Wgdnv(i,j,k,itan1) = WLeft(i,j,k,itan1)
            Wgdnv(i,j,k,itan2) = WLeft(i,j,k,itan2)
            co = cl
            sgnm = (1.0d0)
          else
            ro = rhor
            po = pr
            uno = unr
            Wgdnv(i,j,k,itan1) = WRight(i,j,k,itan1)
            Wgdnv(i,j,k,itan2) = WRight(i,j,k,itan2)
            co = cr
            sgnm = -(1.0d0)
          endif
          rstar = ro + (pstar - po)/co**2
          rstar = max(rstar,smallr)
          cstar = sqrt(abs(gamma*pstar/rstar))
          wstar = (0.500d0)*(cstar*rstar + co*ro)
          spout = co - sgnm*uno
          spin = cstar - sgnm*ustar
          ushock = wstar/rstar - sgnm*ustar
          if (pstar.gt.po) then
            spout = ushock
            spin = ushock
          endif
          frac = (((1.0d0) + (spout + spin)/max(spout-spin,small))/(2.0d
     &0))
          frac = max((0.0d0),min((1.0d0),frac))
          Wgdnv(i,j,k,0) = ro + frac*(rstar - ro)
          Wgdnv(i,j,k,inorm) = uno + frac*(ustar - uno)
          Wgdnv(i,j,k,4) = po + frac*(pstar - po)
          if (spout.le.(0.0d0)) then
            Wgdnv(i,j,k,0) = ro
            Wgdnv(i,j,k,inorm) = uno
            Wgdnv(i,j,k,4) = po
          endif
          if (spin.gt.(0.0d0)) then
            Wgdnv(i,j,k,0) = rstar
            Wgdnv(i,j,k,inorm) = ustar
            Wgdnv(i,j,k,4) = pstar
          endif
          Wgdnv(i,j,k,0) = max(Wgdnv(i,j,k,0) ,smallr)
          Wgdnv(i,j,k,4) = max(Wgdnv(i,j,k,4),smallp)
      enddo
      enddo
      enddo
        return
        end
      subroutine GETFLUX(
     & F
     & ,iFlo0,iFlo1,iFlo2
     & ,iFhi0,iFhi1,iFhi2
     & ,nFcomp
     & ,Wgdnv
     & ,iWgdnvlo0,iWgdnvlo1,iWgdnvlo2
     & ,iWgdnvhi0,iWgdnvhi1,iWgdnvhi2
     & ,nWgdnvcomp
     & ,idir
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL*8 F(
     & iFlo0:iFhi0,
     & iFlo1:iFhi1,
     & iFlo2:iFhi2,
     & 0:nFcomp-1)
      integer nWgdnvcomp
      integer iWgdnvlo0,iWgdnvlo1,iWgdnvlo2
      integer iWgdnvhi0,iWgdnvhi1,iWgdnvhi2
      REAL*8 Wgdnv(
     & iWgdnvlo0:iWgdnvhi0,
     & iWgdnvlo1:iWgdnvhi1,
     & iWgdnvlo2:iWgdnvhi2,
     & 0:nWgdnvcomp-1)
      integer idir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i ,j ,k
        integer inorm ,itan1 ,itan2
        integer inormc,itanc1,itanc2
        REAL*8 r,p,u,v,w,e,ke
        integer spacedim



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
        spacedim = 3
        inorm = 1 + idir
        itan1 = 1 + mod(idir + 1,spacedim)
        itan2 = 1 + mod(idir + 2,spacedim)
        inormc = 1 + idir
        itanc1 = 1 + mod(idir + 1,spacedim)
        itanc2 = 1 + mod(idir + 2,spacedim)
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          r = max(smallr,Wgdnv(i,j,k,0))
          u = Wgdnv(i,j,k,inorm)
          v = Wgdnv(i,j,k,itan1)
          w = Wgdnv(i,j,k,itan2)
          p = max(smallp,Wgdnv(i,j,k,4))
          e = p/r/(gamma - (1.0d0))
          F(i,j,k,0) = r*u
          F(i,j,k,inormc) = r*u*u+p
          F(i,j,k,itanc1) = r*u*v
          F(i,j,k,itanc2) = r*u*w
          ke = (0.500d0)*(u*u + v*v + w*w)
          F(i,j,k,4) = u*r*(e+ke) + u*p
      enddo
      enddo
      enddo
        return
        end
      subroutine UPDATECONS(
     & U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,F
     & ,iFlo0,iFlo1,iFlo2
     & ,iFhi0,iFhi1,iFhi2
     & ,nFcomp
     & ,dtbydx
     & ,idir
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL*8 F(
     & iFlo0:iFhi0,
     & iFlo1:iFhi1,
     & iFlo2:iFhi2,
     & 0:nFcomp-1)
      REAL*8 dtbydx
      integer idir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
        integer i,j,k
        integer ioff,joff,koff
        integer iv
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
        do iv = 0,nUcomp - 1
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
            U(i,j,k,iv) = U(i,j,k,iv)
     & - dtbydx * (F(i+ioff,j+joff,k+koff,iv)
     & - F(i ,j ,k ,iv))
      enddo
      enddo
      enddo
        enddo
        return
        end
      subroutine GETRELGRAD(
     & du
     & ,idulo0,idulo1,idulo2
     & ,iduhi0,iduhi1,iduhi2
     & ,u
     & ,iulo0,iulo1,iulo2
     & ,iuhi0,iuhi1,iuhi2
     & ,idir
     & ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     & ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     & ,hasLo
     & ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     & ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     & ,hasHi
     & ,icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
     & ,icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer idulo0,idulo1,idulo2
      integer iduhi0,iduhi1,iduhi2
      REAL*8 du(
     & idulo0:iduhi0,
     & idulo1:iduhi1,
     & idulo2:iduhi2)
      integer iulo0,iulo1,iulo2
      integer iuhi0,iuhi1,iuhi2
      REAL*8 u(
     & iulo0:iuhi0,
     & iulo1:iuhi1,
     & iulo2:iuhi2)
      integer idir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi
      integer icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
      integer icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
        integer i ,j ,k
        integer ioff,joff,koff
        REAL*8 diff,aver
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
      do k = icenterBoxlo2,icenterBoxhi2
      do j = icenterBoxlo1,icenterBoxhi1
      do i = icenterBoxlo0,icenterBoxhi0
          diff = (0.500d0)*(u(i+ioff,j+joff,k+koff)
     & -u(i-ioff,j-joff,k-koff))
          aver = (0.500d0)*(u(i+ioff,j+joff,k+koff)
     & +u(i-ioff,j-joff,k-koff))
          du(i,j,k) = diff / aver
      enddo
      enddo
      enddo
        if (hasLo .eq. 1) then
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0
            diff = (u(i+ioff,j+joff,k+koff)
     & -u(i ,j ,k ))
            aver = (0.500d0)*(u(i+ioff,j+joff,k+koff)
     & +u(i ,j ,k ))
            du(i,j,k) = diff / aver
      enddo
      enddo
      enddo
        endif
        if (hasHi .eq. 1) then
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0
            diff = (u(i ,j ,k )
     & -u(i-ioff,j-joff,k-koff))
            aver = (0.500d0)*(u(i ,j ,k )
     & +u(i-ioff,j-joff,k-koff))
            du(i,j,k) = diff / aver
      enddo
      enddo
      enddo
        endif
        return
        end
      subroutine GETJUMP(
     & du
     & ,idulo0,idulo1,idulo2
     & ,iduhi0,iduhi1,iduhi2
     & ,u
     & ,iulo0,iulo1,iulo2
     & ,iuhi0,iuhi1,iuhi2
     & ,idir
     & ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     & ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     & ,hasLo
     & ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     & ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     & ,hasHi
     & ,icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
     & ,icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
     & )
      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /
      integer idulo0,idulo1,idulo2
      integer iduhi0,iduhi1,iduhi2
      REAL*8 du(
     & idulo0:iduhi0,
     & idulo1:iduhi1,
     & idulo2:iduhi2)
      integer iulo0,iulo1,iulo2
      integer iuhi0,iuhi1,iuhi2
      REAL*8 u(
     & iulo0:iuhi0,
     & iulo1:iuhi1,
     & iulo2:iuhi2)
      integer idir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi
      integer icenterBoxlo0,icenterBoxlo1,icenterBoxlo2
      integer icenterBoxhi0,icenterBoxhi1,icenterBoxhi2
        integer i ,j ,k
        integer ioff,joff,koff
        REAL*8 diff,aver
        ioff = CHF_ID(0,idir)
        joff = CHF_ID(1,idir)
        koff = CHF_ID(2,idir)
      do k = icenterBoxlo2,icenterBoxhi2
      do j = icenterBoxlo1,icenterBoxhi1
      do i = icenterBoxlo0,icenterBoxhi0
          diff = u(i+ioff,j+joff,k+koff)
          aver = u(i-ioff,j-joff,k-koff)
          diff = diff/aver
          if (diff.le.(1.0d0)) diff = (1.0d0)/diff
          du(i,j,k) = diff - (1.0d0)
      enddo
      enddo
      enddo
        if (hasLo .eq. 1) then
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0
            diff = u(i+ioff,j+joff,k+koff)
            aver = u(i ,j ,k )
            diff = diff/aver
            if (diff .le. (1.0d0)) diff = (1.0d0)/diff
            diff = diff -(1.0d0)
            du(i,j,k) = diff
      enddo
      enddo
      enddo
        endif
        if (hasHi .eq. 1) then
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0
            diff = u(i-ioff,j-joff,k-koff)
            aver = u(i ,j ,k )
            diff = diff/aver
            if (diff .le. (1.0d0)) diff = (1.0d0)/diff
            diff = diff - (1.0d0)
            du(i,j,k) = diff / aver
      enddo
      enddo
      enddo
        endif
        return
        end
      subroutine COMPUTEPRESSURE(
     & pressure
     & ,ipressurelo0,ipressurelo1,ipressurelo2
     & ,ipressurehi0,ipressurehi1,ipressurehi2
     & ,U
     & ,iUlo0,iUlo1,iUlo2
     & ,iUhi0,iUhi1,iUhi2
     & ,nUcomp
     & ,iboxlo0,iboxlo1,iboxlo2
     & ,iboxhi0,iboxhi1,iboxhi2
     & )
      implicit none
      integer ipressurelo0,ipressurelo1,ipressurelo2
      integer ipressurehi0,ipressurehi1,ipressurehi2
      REAL*8 pressure(
     & ipressurelo0:ipressurehi0,
     & ipressurelo1:ipressurehi1,
     & ipressurelo2:ipressurehi2)
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL*8 U(
     & iUlo0:iUhi0,
     & iUlo1:iUhi1,
     & iUlo2:iUhi2,
     & 0:nUcomp-1)
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2
      integer i,j,k
      REAL*8 uu,vv,ww
      REAL*8 rho, re, ke, p



        REAL*8 gamma,smallp,smallr,smallu,small
        parameter ( small = 1e-6 )
        common /eos/ gamma,smallp,smallr,smallu
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0
          rho = U(i,j,k,0)
          uu = U(i,j,k,1)/rho
          vv = U(i,j,k,2)/rho
          ww = U(i,j,k,3)/rho
          ke = (0.500d0)*(uu*uu + vv*vv + ww*ww)
          re = U(i,j,k,4) - rho*ke
          p = (gamma - (1.0d0))*re
          p = max(p,smallp)
          pressure(i,j,k) = p
      enddo
      enddo
      enddo
      return
      end
