#include "REAL.H"
#include "SPACE.H"
#include "CONSTANTS.H"



#include "CONSTANTS.H"
#include "LGintegrator.H"


      subroutine SOLIDBC(
     &           F
     &           ,iFlo0,iFlo1,iFlo2
     &           ,iFhi0,iFhi1,iFhi2
     &           ,nFcomp
     &           ,Wextrap
     &           ,iWextraplo0,iWextraplo1,iWextraplo2
     &           ,iWextraphi0,iWextraphi1,iWextraphi2
     &           ,nWextrapcomp
     &           ,lohisign
     &           ,dx
     &           ,dir
     &           ,iboxlo0,iboxlo1,iboxlo2
     &           ,iboxhi0,iboxhi1,iboxhi2
     &           )

      implicit none
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL_T F(
     &           iFlo0:iFhi0,
     &           iFlo1:iFhi1,
     &           iFlo2:iFhi2,
     &           0:nFcomp-1)
      integer nWextrapcomp
      integer iWextraplo0,iWextraplo1,iWextraplo2
      integer iWextraphi0,iWextraphi1,iWextraphi2
      REAL_T Wextrap(
     &           iWextraplo0:iWextraphi0,
     &           iWextraplo1:iWextraphi1,
     &           iWextraplo2:iWextraphi2,
     &           0:nWextrapcomp-1)
      integer lohisign
      REAL_T dx
      integer dir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        real_t p,rho,unorm,speed
        integer i,j,k

#include "RampCommon.fh"
#include "EosCommon.fh"

        
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

          p = Wextrap(i,j,k,WPRES)
          rho = max(Wextrap(i,j,k,WRHO),smallr)
          unorm = Wextrap(i,j,k,WVELX + dir)

          speed = sqrt(gamma*p/rho)

          F(i,j,k,URHO) = zero

          
          F(i,j,k,UMOMX) = zero
          F(i,j,k,UMOMY) = zero
          F(i,j,k,UMOMZ) = zero

          F(i,j,k,UMOMX + dir) = p + lohisign * rho * unorm * speed
          F(i,j,k,UENG) = zero
        
      enddo
      enddo
      enddo

        return
        end


      subroutine SLOPEBCS(
     &           dW
     &           ,idWlo0,idWlo1,idWlo2
     &           ,idWhi0,idWhi1,idWhi2
     &           ,ndWcomp
     &           ,W
     &           ,iWlo0,iWlo1,iWlo2
     &           ,iWhi0,iWhi1,iWhi2
     &           ,nWcomp
     &           ,dx
     &           ,dir
     &           ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     &           ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     &           ,hasLo
     &           ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     &           ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     &           ,hasHi
     &           )

      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /


      integer ndWcomp
      integer idWlo0,idWlo1,idWlo2
      integer idWhi0,idWhi1,idWhi2
      REAL_T dW(
     &           idWlo0:idWhi0,
     &           idWlo1:idWhi1,
     &           idWlo2:idWhi2,
     &           0:ndWcomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL_T W(
     &           iWlo0:iWhi0,
     &           iWlo1:iWhi1,
     &           iWlo2:iWhi2,
     &           0:nWcomp-1)
      REAL_T dx
      integer dir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi

        integer i,j,k,ioff,joff,koff
        integer inorm,itan1,itan2,spacedim
        real_t dvhi,dvlo,dvmin

        spacedim = CH_SPACEDIM

        
        ioff = CHF_ID(0,dir)
        joff = CHF_ID(1,dir)
        koff = CHF_ID(2,dir)

        
        inorm = WVELX + dir
        itan1 = WVELX + mod(dir + 1,spacedim)
        itan2 = WVELX + mod(dir + 2,spacedim)

        if (hasLo .eq. 1) then
          
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0

            dW(i,j,k,WRHO) = zero
            dW(i,j,k,WPRES) = zero

            dvhi = W(i + ioff,j + joff,k + koff,inorm) -
     &             W(i       ,j       ,k       ,inorm)
            dvlo = W(i,j,k,inorm)*two

            dvmin = min(two*abs(dvhi),abs(dvlo))*sign(one,dvlo)

            if (dvlo*dvhi .lt. zero) dvmin = zero

            
            dW(i,j,k,inorm) = dvmin
            dW(i,j,k,itan1) = zero
            dW(i,j,k,itan2) = zero
          
      enddo
      enddo
      enddo
        endif

        if (hasHi .eq. 1) then
          
      do k = ihiBoxlo2,ihiBoxhi2
      do j = ihiBoxlo1,ihiBoxhi1
      do i = ihiBoxlo0,ihiBoxhi0

            dW(i,j,k,WRHO) = zero
            dW(i,j,k,WPRES) = zero

            dvhi = W(i       ,j       ,k       ,inorm) -
     &             W(i - ioff,j - joff,k - koff,inorm)
            dvlo = W(i,j,k,inorm)*two

            dvmin = min(two*abs(dvhi),abs(dvlo))*sign(one,dvlo)

            if (dvlo*dvhi .lt. zero) dvmin = zero

            
            dW(i,j,k,inorm) = dvmin
            dW(i,j,k,itan1) = zero
            dW(i,j,k,itan2) = zero
          
      enddo
      enddo
      enddo
        endif

        return
        end
