#include "REAL.H"
#include "SPACE.H"
#include "CONSTANTS.H"


#include "CONSTANTS.H"
#include "LGintegrator.H"


      subroutine SETWAVE(
     &           augamma
     &           ,auambientDensity
     &           ,audeltaDensity
     &           ,aupressure
     &           ,auwaveNumber
     &           ,aucenter
     &           ,auvelocity
     &           ,auartvisc
     &           )

      implicit none
      REAL_T augamma
      REAL_T auambientDensity
      REAL_T audeltaDensity
      integer aupressure
      integer auwaveNumber(0:2)
      REAL_T aucenter(0:2)
      REAL_T auvelocity(0:2)
      REAL_T auartvisc

#include "WaveCommon.fh"
#include "EosCommon.fh"

        real_t r0,p0,umag

        gamma = augamma

        ambientdensity = auambientDensity
        deltadensity = audeltaDensity

        pressure = aupressure

        
        iwave = auwaveNumber(0)
        jwave = auwaveNumber(1)
        kwave = auwaveNumber(2)

        
        centerx = aucenter(0)
        centery = aucenter(1)
        centerz = aucenter(2)

        
        velx = auvelocity(0)
        vely = auvelocity(1)
        velz = auvelocity(2)

        artvisc = auartvisc

        r0 = ambientdensity
        p0 = half

        umag = sqrt(gamma*p0/r0)

        smallr = small*r0
        smallu = small*umag
        smallp = small*r0*half*umag*umag

        return
        end


      subroutine WAVEINIT(
     &           U
     &           ,iUlo0,iUlo1,iUlo2
     &           ,iUhi0,iUhi1,iUhi2
     &           ,nUcomp
     &           ,dx
     &           ,iboxlo0,iboxlo1,iboxlo2
     &           ,iboxhi0,iboxhi1,iboxhi2
     &           )

      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL_T U(
     &           iUlo0:iUhi0,
     &           iUlo1:iUhi1,
     &           iUlo2:iUhi2,
     &           0:nUcomp-1)
      REAL_T dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        real_t nnum
        real_t ke,r0,p0,r,p,d
        real_t pi
        integer i,j,k
        real_t xnum,ynum,znum
        real_t xcenter,ycenter,zcenter
        real_t uu,vv,ww
        real_t x,y,z

#include "WaveCommon.fh"
#include "EosCommon.fh"

        
        xnum = iwave
        ynum = jwave
        znum = kwave

         nnum = xnum*xnum + ynum*ynum + znum*znum
        nnum = sqrt(nnum)

        if (nnum .ne. zero) then
          
          xnum = xnum / nnum
          ynum = ynum / nnum
          znum = znum / nnum
        endif

        
        xcenter = centerx
        ycenter = centery
        zcenter = centerz

        pi = four*atan(one)

        r0 = ambientdensity
        p0 = half

        
        uu = velx
        vv = vely
        ww = velz

        ke = half*(uu*uu + vv*vv + ww*ww)

        
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

          
          x = (i + half)*dx - xcenter
          y = (j + half)*dx - ycenter
          z = (k + half)*dx - zcenter

          d = x*xnum + y*ynum + z*znum

          r = r0 + deltadensity * half * (cos(two*pi*nnum*d) + one)

          if (pressure .eq. zero) then
            p = (r/r0)**gamma * p0
          else
            p = p0
          endif

          U(i,j,k,URHO) = r

          
          U(i,j,k,UMOMX) = uu*r
          U(i,j,k,UMOMY) = vv*r
          U(i,j,k,UMOMZ) = ww*r

          U(i,j,k,UENG) = p/(gamma - one) + r*ke
        
      enddo
      enddo
      enddo

        return
        end
