#include "REAL.H"
#include "SPACE.H"
#include "CONSTANTS.H"


#include "CONSTANTS.H"
#include "LGintegrator.H"


      subroutine SETEXPLOSION(
     &           augamma
     &           ,aums
     &           ,aucenter
     &           ,ausize
     &           ,auvelocity
     &           ,auartvisc
     &           )

      implicit none
      REAL_T augamma
      REAL_T aums
      REAL_T aucenter(0:2)
      REAL_T ausize
      REAL_T auvelocity(0:2)
      REAL_T auartvisc

#include "ExplosionCommon.fh"
#include "EosCommon.fh"

        real_t r0,p0,p,ww,umag

        gamma = augamma
        ms = aums

        
        centerx = aucenter(0)
        centery = aucenter(1)
        centerz = aucenter(2)

        size = ausize

        
        velx = auvelocity(0)
        vely = auvelocity(1)
        velz = auvelocity(2)

        artvisc = auartvisc

        p0 = one
        r0 = gamma

        ww = ms*r0

        p = ((ms**2 - one)*(two*gamma)/(gamma + one) + one)*p0

        umag = (p - p0)/ww

        smallr = small*r0
        smallu = small*umag
        smallp = small*r0*half*umag*umag

        return
        end


      subroutine EXPLOSIONINIT(
     &           U
     &           ,iUlo0,iUlo1,iUlo2
     &           ,iUhi0,iUhi1,iUhi2
     &           ,nUcomp
     &           ,dx
     &           ,iboxlo0,iboxlo1,iboxlo2
     &           ,iboxhi0,iboxhi1,iboxhi2
     &           )

      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL_T U(
     &           iUlo0:iUhi0,
     &           iUlo1:iUhi1,
     &           iUlo2:iUhi2,
     &           0:nUcomp-1)
      REAL_T dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        real_t ke,r0,p0,p,uu,vv,ww,umag,r
        integer i,j,k
        real_t x,y,z
        real_t xcenter,ycenter,zcenter
        real_t rad0sqr,radsqr

#include "ExplosionCommon.fh"
#include "EosCommon.fh"

        
        xcenter = centerx
        ycenter = centery
        zcenter = centerz

        rad0sqr = size*size

        p0 = one
        r0 = gamma

        ww = ms*r0

        p = ((ms**2 - one)*(two*gamma)/(gamma + one) + one)*p0
        r = one/(one/r0 - (p - p0)/ww**2)

        umag = (p - p0)/ww

        
        uu = velx
        vv = vely
        ww = velz

        ke = half*(uu*uu + vv*vv + ww*ww)

        
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

          
          x = (i + half)*dx - xcenter
          y = (j + half)*dx - ycenter
          z = (k + half)*dx - zcenter

          radsqr = x*x + y*y + z*z

          if (radsqr .ge. rad0sqr) then
            U(i,j,k,URHO) = r0

            
            U(i,j,k,UMOMX) = uu*r0
            U(i,j,k,UMOMY) = vv*r0
            U(i,j,k,UMOMZ) = ww*r0

            U(i,j,k,UENG) = p0/(gamma - one) + r0*ke
          else
            U(i,j,k,URHO) = r

            
            U(i,j,k,UMOMX) = uu*r
            U(i,j,k,UMOMY) = vv*r
            U(i,j,k,UMOMZ) = ww*r

            U(i,j,k,UENG) = p/(gamma - one) + r*ke
          endif
        
      enddo
      enddo
      enddo

        return
        end
