#include "REAL.H"
#include "SPACE.H"
#include "CONSTANTS.H"


#include "CONSTANTS.H"
#include "LGintegrator.H"


      subroutine SETRAMP(
     &           augamma
     &           ,aualpha
     &           ,aums
     &           ,auxcorner
     &           ,auartvisc
     &           )

      implicit none
      REAL_T augamma
      REAL_T aualpha
      REAL_T aums
      REAL_T auxcorner
      REAL_T auartvisc

        real_t pi

#include "RampCommon.fh"
#include "EosCommon.fh"

        real_t ke,r0,p0,p,uu,vv,ww,umag,r
        real_t sinalpha,cosalpha,tanalpha

        gamma = augamma

        alpha = aualpha ! alpha is input in degrees; conversion is done
        pi = atan(one)*four
        alpha = alpha*pi/(nine*twenty)

        ms = aums
        xcorner = auxcorner

        artvisc = auartvisc

        cosalpha = cos(alpha)
        sinalpha = sin(alpha)
        tanalpha = tan(alpha)

        p0 = one
        r0 = gamma

        ww = ms*r0

        p = ((ms**2 - one)*(two*gamma)/(gamma + one) + one)*p0
        r = one/(one/r0 - (p - p0)/ww**2)

        umag = (p - p0)/ww

        
        uu =  umag*cosalpha
        vv = -umag*sinalpha
        ww =  zero

        ke = half*(uu*uu + vv*vv + ww*ww)
        smallr = small*r0
        smallu = small*umag
        smallp = small*r0*half*umag*umag

        return
        end


      subroutine RAMPINIT(
     &           U
     &           ,iUlo0,iUlo1,iUlo2
     &           ,iUhi0,iUhi1,iUhi2
     &           ,nUcomp
     &           ,dx
     &           ,iboxlo0,iboxlo1,iboxlo2
     &           ,iboxhi0,iboxhi1,iboxhi2
     &           )

      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL_T U(
     &           iUlo0:iUhi0,
     &           iUlo1:iUhi1,
     &           iUlo2:iUhi2,
     &           0:nUcomp-1)
      REAL_T dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        real_t ke,r0,p0,p,uu,vv,ww,umag,r
        real_t sinalpha,cosalpha,tanalpha
        integer i,j,k
        real_t x,y,z
        real_t xofy

#include "RampCommon.fh"
#include "EosCommon.fh"

        cosalpha = cos(alpha)
        sinalpha = sin(alpha)
        tanalpha = tan(alpha)

        p0 = one
        r0 = gamma

        ww = ms*r0

        p = ((ms**2 - one)*(two*gamma)/(gamma + one) + one)*p0
        r = one/(one/r0 - (p - p0)/ww**2)

        umag = (p - p0)/ww

        
        uu = umag*cosalpha
        vv =-umag*sinalpha
        ww = zero

        ke = half*(uu*uu + vv*vv + ww*ww)

        
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

          
          x = (i + half)*dx
          y = (j + half)*dx
          z = (k + half)*dx

          xofy = xcorner + y*tanalpha

          if (x .ge. xofy) then
            U(i,j,k,URHO) = r0

            
            U(i,j,k,UMOMX) = zero
            U(i,j,k,UMOMY) = zero
            U(i,j,k,UMOMZ) = zero

            U(i,j,k,UENG) = p0/(gamma - one)
          else
            U(i,j,k,URHO) = r

            
            U(i,j,k,UMOMX) = uu*r
            U(i,j,k,UMOMY) = vv*r
            U(i,j,k,UMOMZ) = zero

            U(i,j,k,UENG) = p/(gamma - one) + r*ke
          endif
        
      enddo
      enddo
      enddo

        return
        end


      subroutine RAMPBC(
     &           F
     &           ,iFlo0,iFlo1,iFlo2
     &           ,iFhi0,iFhi1,iFhi2
     &           ,nFcomp
     &           ,W
     &           ,iWlo0,iWlo1,iWlo2
     &           ,iWhi0,iWhi1,iWhi2
     &           ,nWcomp
     &           ,time
     &           ,lohisign
     &           ,dx
     &           ,dir
     &           ,iboxlo0,iboxlo1,iboxlo2
     &           ,iboxhi0,iboxhi1,iboxhi2
     &           )

      implicit none
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL_T F(
     &           iFlo0:iFhi0,
     &           iFlo1:iFhi1,
     &           iFlo2:iFhi2,
     &           0:nFcomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL_T W(
     &           iWlo0:iWhi0,
     &           iWlo1:iWhi1,
     &           iWlo2:iWhi2,
     &           0:nWcomp-1)
      REAL_T time
      integer lohisign
      REAL_T dx
      integer dir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        real_t ke,r0,p0,umag,p,r
        real_t x,y,z
        real_t xofy,rg,pg,ws
        real_t  ug,vg,wg
        real_t  uu,vv,ww
        integer i,j,k
        real_t cosalpha,sinalpha,tanalpha

#include "RampCommon.fh"
#include "EosCommon.fh"

        cosalpha = cos(alpha)
        sinalpha = sin(alpha)
        tanalpha = tan(alpha)

        r0 = gamma
        p0 = one
        ws = ms*r0
        p = ((ms**2-one)*two*gamma/(gamma + one) + one)*p0
        umag = (p - p0)/ws
        r = one/(one/r0 - (p - p0)/ws**2)

        
        uu = umag*cosalpha
        vv =-umag*sinalpha
        ww = zero

        ke = half*(uu*uu + vv*vv + ww*ww)

        if (dir .eq. 1) then
          
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

            
            x = (i + half)*dx
            y =  j        *dx
            z = (k + half)*dx

            if (lohisign .eq. 1) then
              xofy = xcorner + y*tanalpha + ms*time/cosalpha

              if (x .ge. xofy) then
                F(i,j,k,URHO) = zero

                
                F(i,j,k,UMOMX) = zero
                F(i,j,k,UMOMY) = p0
                F(i,j,k,UMOMZ) = zero

                F(i,j,k,UENG) = zero
              else
                F(i,j,k,URHO) = vv*r

                
                F(i,j,k,UMOMX) = uu*vv*r
                F(i,j,k,UMOMY) = vv*vv*r + p
                F(i,j,k,UMOMZ) = zero

                F(i,j,k,UENG) = vv*(p/(gamma - one) + r*ke + p)
              endif
            else
              if (x .le. xcorner) then
                rg = W(i,j,k,WRHO)

                
                ug = W(i,j,k,WVELX)
                vg = W(i,j,k,WVELY)
                wg = W(i,j,k,WVELZ)

                pg = W(i,j,k,WPRES)

                F(i,j,k,URHO) = vg*rg

                
                F(i,j,k,UMOMX) = vg*ug*rg
                F(i,j,k,UMOMY) = vg*vg*rg + pg
                F(i,j,k,UMOMZ) = vg*wg*rg

                ke = half*(ug*ug + vg*vg + wg*wg)
                F(i,j,k,UENG) = vg*(pg/(gamma - one) +
     &                                                ke*rg + pg)
              endif
            endif
          
      enddo
      enddo
      enddo
        endif

        if (dir .eq. 0) then
          
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

            if (lohisign .eq. -1) then
              F(i,j,k,URHO) = r*uu

              
              F(i,j,k,UMOMX) = r*uu*uu + p
              F(i,j,k,UMOMY) = r*uu*vv
              F(i,j,k,UMOMZ) = r*uu*ww

              F(i,j,k,UENG) = uu*(p/(gamma - one) + ke*r + p)
            else
              F(i,j,k,URHO) = zero

              
              F(i,j,k,UMOMX) = p0
              F(i,j,k,UMOMY) = zero
              F(i,j,k,UMOMZ) = zero

              F(i,j,k,UENG) = zero
            endif
          
      enddo
      enddo
      enddo
        endif

        return
        end


      subroutine RAMPSOLIDBC(
     &           F
     &           ,iFlo0,iFlo1,iFlo2
     &           ,iFhi0,iFhi1,iFhi2
     &           ,nFcomp
     &           ,Wextrap
     &           ,iWextraplo0,iWextraplo1,iWextraplo2
     &           ,iWextraphi0,iWextraphi1,iWextraphi2
     &           ,nWextrapcomp
     &           ,lohisign
     &           ,dx
     &           ,dir
     &           ,iboxlo0,iboxlo1,iboxlo2
     &           ,iboxhi0,iboxhi1,iboxhi2
     &           )

      implicit none
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL_T F(
     &           iFlo0:iFhi0,
     &           iFlo1:iFhi1,
     &           iFlo2:iFhi2,
     &           0:nFcomp-1)
      integer nWextrapcomp
      integer iWextraplo0,iWextraplo1,iWextraplo2
      integer iWextraphi0,iWextraphi1,iWextraphi2
      REAL_T Wextrap(
     &           iWextraplo0:iWextraphi0,
     &           iWextraplo1:iWextraphi1,
     &           iWextraplo2:iWextraphi2,
     &           0:nWextrapcomp-1)
      integer lohisign
      REAL_T dx
      integer dir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        real_t p,rho,unorm,speed
        integer i,j,k

#include "RampCommon.fh"
#include "EosCommon.fh"

        
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

          p = Wextrap(i,j,k,WPRES)
          rho = max(Wextrap(i,j,k,WRHO),smallr)
          unorm = Wextrap(i,j,k,WVELX + dir)

          speed = sqrt(gamma*p/rho)

          F(i,j,k,URHO) = zero

          
          F(i,j,k,UMOMX) = zero
          F(i,j,k,UMOMY) = zero
          F(i,j,k,UMOMZ) = zero

          F(i,j,k,UMOMX + dir) = p + lohisign * rho * unorm * speed
          F(i,j,k,UENG) = zero
        
      enddo
      enddo
      enddo

        return
        end


      subroutine RAMPSLOPEBCS(
     &           dW
     &           ,idWlo0,idWlo1,idWlo2
     &           ,idWhi0,idWhi1,idWhi2
     &           ,ndWcomp
     &           ,W
     &           ,iWlo0,iWlo1,iWlo2
     &           ,iWhi0,iWhi1,iWhi2
     &           ,nWcomp
     &           ,dx
     &           ,dir
     &           ,iloBoxlo0,iloBoxlo1,iloBoxlo2
     &           ,iloBoxhi0,iloBoxhi1,iloBoxhi2
     &           ,hasLo
     &           ,ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
     &           ,ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
     &           ,hasHi
     &           )

      implicit none
      integer CHF_ID(0:2,0:2)
      data CHF_ID/ 1,0,0 ,0,1,0 ,0,0,1 /


      integer ndWcomp
      integer idWlo0,idWlo1,idWlo2
      integer idWhi0,idWhi1,idWhi2
      REAL_T dW(
     &           idWlo0:idWhi0,
     &           idWlo1:idWhi1,
     &           idWlo2:idWhi2,
     &           0:ndWcomp-1)
      integer nWcomp
      integer iWlo0,iWlo1,iWlo2
      integer iWhi0,iWhi1,iWhi2
      REAL_T W(
     &           iWlo0:iWhi0,
     &           iWlo1:iWhi1,
     &           iWlo2:iWhi2,
     &           0:nWcomp-1)
      REAL_T dx
      integer dir
      integer iloBoxlo0,iloBoxlo1,iloBoxlo2
      integer iloBoxhi0,iloBoxhi1,iloBoxhi2
      integer hasLo
      integer ihiBoxlo0,ihiBoxlo1,ihiBoxlo2
      integer ihiBoxhi0,ihiBoxhi1,ihiBoxhi2
      integer hasHi

        integer i,j,k,ioff,joff,koff
        integer inorm,itan1,itan2,spacedim
        real_t dvhi,dvlo,dvmin,x

#include "RampCommon.fh"

        spacedim = CH_SPACEDIM

        
        ioff = CHF_ID(0,dir)
        joff = CHF_ID(1,dir)
        koff = CHF_ID(2,dir)

        
        inorm = WVELX + dir
        itan1 = WVELX + mod(dir + 1,spacedim)
        itan2 = WVELX + mod(dir + 2,spacedim)

        if ((dir .eq. 1) .and. (hasLo .eq. 1)) then
          
      do k = iloBoxlo2,iloBoxhi2
      do j = iloBoxlo1,iloBoxhi1
      do i = iloBoxlo0,iloBoxhi0

            x = (i + half)*dx

            if (x .ge. xcorner) then
              dW(i,j,k,WRHO) = zero
              dW(i,j,k,WPRES) = zero

              dvhi = W(i + ioff,j + joff,k + koff,inorm) -
     &               W(i       ,j       ,k       ,inorm)
              dvlo = W(i       ,j       ,k       ,inorm)*two

              dvmin = min(two*abs(dvhi),abs(dvlo))*sign(one,dvlo)

              if (dvlo*dvhi .lt. zero) dvmin = zero

              
              dW(i,j,k,inorm) = dvmin
              dW(i,j,k,itan1) = zero
              dW(i,j,k,itan2) = zero
            endif
          
      enddo
      enddo
      enddo
        endif

        return
        end


      subroutine RAMPARTVISC(
     &           F
     &           ,iFlo0,iFlo1,iFlo2
     &           ,iFhi0,iFhi1,iFhi2
     &           ,nFcomp
     &           ,U
     &           ,iUlo0,iUlo1,iUlo2
     &           ,iUhi0,iUhi1,iUhi2
     &           ,nUcomp
     &           ,divu
     &           ,idivulo0,idivulo1,idivulo2
     &           ,idivuhi0,idivuhi1,idivuhi2
     &           ,lohisign
     &           ,dx
     &           ,dir
     &           ,iboxlo0,iboxlo1,iboxlo2
     &           ,iboxhi0,iboxhi1,iboxhi2
     &           )

      implicit none
      integer nFcomp
      integer iFlo0,iFlo1,iFlo2
      integer iFhi0,iFhi1,iFhi2
      REAL_T F(
     &           iFlo0:iFhi0,
     &           iFlo1:iFhi1,
     &           iFlo2:iFhi2,
     &           0:nFcomp-1)
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL_T U(
     &           iUlo0:iUhi0,
     &           iUlo1:iUhi1,
     &           iUlo2:iUhi2,
     &           0:nUcomp-1)
      integer idivulo0,idivulo1,idivulo2
      integer idivuhi0,idivuhi1,idivuhi2
      REAL_T divu(
     &           idivulo0:idivuhi0,
     &           idivulo1:idivuhi1,
     &           idivulo2:idivuhi2)
      integer lohisign
      REAL_T dx
      integer dir
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        integer i,j,k
        real_t x
        real_t fc,dv,s

#include "RampCommon.fh"
#include "EosCommon.fh"

        if (dir .eq. 1) then
          if (lohisign .eq. -1) then
            
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

              x = (i + half)*dx;

                if (x .gt. xcorner) then
                  fc = F   (i, j, k,UMOMX + dir)
                  dv = divu(i, j, k)
                  s  = U   (i, j, k,UMOMX + dir)

                  F(i,j,k,UMOMX + dir) = fc - lohisign*artvisc*min(dv,zero)*(2*s)
                endif
            
      enddo
      enddo
      enddo
          endif
        endif

        return
        end
