#include "REAL.H"
#include "SPACE.H"
#include "CONSTANTS.H"


#include "CONSTANTS.H"
#include "LGintegrator.H"


      subroutine SETBENCHMARK(
     &           augamma
     &           ,auenergy
     &           ,aurho0
     &           ,aup0
     &           ,aucenter
     &           ,ausize
     &           ,auvelocity
     &           ,auartvisc
     &           )

      implicit none
      REAL_T augamma
      REAL_T auenergy
      REAL_T aurho0
      REAL_T aup0
      REAL_T aucenter(0:2)
      REAL_T ausize
      REAL_T auvelocity(0:2)
      REAL_T auartvisc

#include "BenchmarkCommon.fh"
#include "EosCommon.fh"

        real_t p,umag, e, vol

        gamma = augamma
        energy = auenergy
        rho0 = aurho0
        p0 = aup0

        
        centerx = aucenter(0)
        centery = aucenter(1)
        centerz = aucenter(2)

        size = ausize

        
        velx = auvelocity(0)
        vely = auvelocity(1)
        velz = auvelocity(2)

        artvisc = auartvisc



        vol = Pi*size*size*four*size/three

        e = energy/vol

        p = ((gamma + 1)*e + one)*p0


        smallr = small*rho0
        smallu = small*umag
        smallp = small*p

        return
        end


      subroutine BENCHMARKINIT(
     &           U
     &           ,iUlo0,iUlo1,iUlo2
     &           ,iUhi0,iUhi1,iUhi2
     &           ,nUcomp
     &           ,sumScaledEnergy
     &           ,dx
     &           ,iboxlo0,iboxlo1,iboxlo2
     &           ,iboxhi0,iboxhi1,iboxhi2
     &           )

      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL_T U(
     &           iUlo0:iUhi0,
     &           iUlo1:iUhi1,
     &           iUlo2:iUhi2,
     &           0:nUcomp-1)
      REAL_T sumScaledEnergy
      REAL_T dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        real_t ke, p,r, e, e0, vol
        REAL_T uu,vv,ww
        integer i,j,k
        real_t x,y,z
        real_t xcenter,ycenter,zcenter
        real_t rad0sqr,radsqr, cellVol

#include "BenchmarkCommon.fh"
#include "EosCommon.fh"

        
        xcenter = centerx
        ycenter = centery
        zcenter = centerz

        rad0sqr = size*size

        
        uu = velx
        vv = vely
        ww = velz

        ke = half*(uu*uu + vv*vv + ww*ww)



        vol = Pi*size*size*four*size/three
        cellVol = dx*dx*dx


        e = energy/vol

        e0 = p0/(gamma - one) + rho0*ke

        p = (gamma-1)*e + p0



        
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

          
          x = (i + half)*dx - xcenter
          y = (j + half)*dx - ycenter
          z = (k + half)*dx - zcenter

          radsqr = x*x + y*y + z*z

          if (radsqr .ge. rad0sqr) then
            U(i,j,k,URHO) = rho0

            
            U(i,j,k,UMOMX) = uu*rho0
            U(i,j,k,UMOMY) = vv*rho0
            U(i,j,k,UMOMZ) = ww*rho0

            U(i,j,k,UENG) = e0
          else
            U(i,j,k,URHO) = rho0

            
            U(i,j,k,UMOMX) = uu*r
            U(i,j,k,UMOMY) = vv*r
            U(i,j,k,UMOMZ) = ww*r

            U(i,j,k,UENG) = e + e0
            sumScaledEnergy = sumScaledEnergy + e*cellVol/energy
          endif
        
      enddo
      enddo
      enddo

        return
        end



      subroutine BENCHMARKINITCORRECT(
     &           U
     &           ,iUlo0,iUlo1,iUlo2
     &           ,iUhi0,iUhi1,iUhi2
     &           ,nUcomp
     &           ,scaling
     &           ,sumScaledEnergy
     &           ,dx
     &           ,iboxlo0,iboxlo1,iboxlo2
     &           ,iboxhi0,iboxhi1,iboxhi2
     &           )

      implicit none
      integer nUcomp
      integer iUlo0,iUlo1,iUlo2
      integer iUhi0,iUhi1,iUhi2
      REAL_T U(
     &           iUlo0:iUhi0,
     &           iUlo1:iUhi1,
     &           iUlo2:iUhi2,
     &           0:nUcomp-1)
      REAL_T scaling
      REAL_T sumScaledEnergy
      REAL_T dx
      integer iboxlo0,iboxlo1,iboxlo2
      integer iboxhi0,iboxhi1,iboxhi2

        real_t ke,p, e, e0, vol
        REAL_T uu,vv,ww
        integer i,j,k
        real_t x,y,z
        real_t xcenter,ycenter,zcenter
        real_t rad0sqr,radsqr, cellVol

#include "BenchmarkCommon.fh"
#include "EosCommon.fh"

        
        xcenter = centerx
        ycenter = centery
        zcenter = centerz

        rad0sqr = size*size

        
        uu = velx
        vv = vely
        ww = velz

        ke = half*(uu*uu + vv*vv + ww*ww)




        vol = Pi*size*size*four*size/three
        cellVol = dx*dx*dx

        e = scaling*energy/vol

        e0 = p0/(gamma - one) + rho0*ke

        p = (gamma-1)*e + p0

        
      do k = iboxlo2,iboxhi2
      do j = iboxlo1,iboxhi1
      do i = iboxlo0,iboxhi0

          
          x = (i + half)*dx - xcenter
          y = (j + half)*dx - ycenter
          z = (k + half)*dx - zcenter

          radsqr = x*x + y*y + z*z

          if (radsqr .lt. rad0sqr) then

            U(i,j,k,UENG) = e + e0
            sumScaledEnergy = sumScaledEnergy + e*cellVol/energy
          endif
        
      enddo
      enddo
      enddo

        return
        end


