#ifndef _PATCHGODUNOVF_F_H_
#define _PATCHGODUNOVF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure MINFLAT ...
//
#define FORT_MINFLAT FORTRAN_NAME( MINFLAT ,minflat )
void 
FORT_MINFLAT(
      CHFp_FRA1(flattening)
      ,CHFp_CONST_FRA(zetaDir)
      ,CHFp_CONST_FRA(du)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETDPTWO ...
//
#define FORT_GETDPTWO FORTRAN_NAME( GETDPTWO ,getdptwo )
void 
FORT_GETDPTWO(
      CHFp_FRA1(delta2p)
      ,CHFp_CONST_FRA1(delta1p)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure GETFLAT ...
//
#define FORT_GETFLAT FORTRAN_NAME( GETFLAT ,getflat )
void 
FORT_GETFLAT(
      CHFp_FRA1(zetaTwiddle)
      ,CHFp_CONST_FRA1(delta1p)
      ,CHFp_CONST_FRA1(delta2p)
      ,CHFp_CONST_FRA1(bulkMin)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETGRAD ...
//
#define FORT_GETGRAD FORTRAN_NAME( GETGRAD ,getgrad )
void 
FORT_GETGRAD(
      CHFp_FRA1(du)
      ,CHFp_CONST_FRA1(u)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure MAGNITUDE ...
//
#define FORT_MAGNITUDE FORTRAN_NAME( MAGNITUDE ,magnitude )
void 
FORT_MAGNITUDE(
      CHFp_FRA1(magdata)
      ,CHFp_CONST_FRA(data)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure MIN3PTS ...
//
#define FORT_MIN3PTS FORTRAN_NAME( MIN3PTS ,min3pts )
void 
FORT_MIN3PTS(
      CHFp_FRA1(mindata)
      ,CHFp_CONST_FRA1(data)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure SECONDSLOPEDIFFS ...
//
#define FORT_SECONDSLOPEDIFFS FORTRAN_NAME( SECONDSLOPEDIFFS ,secondslopediffs )
void 
FORT_SECONDSLOPEDIFFS(
      CHFp_FRA(deltaWC)
      ,CHFp_FRA(deltaWL)
      ,CHFp_FRA(deltaWR)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_INT(numSlopes)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure FOURTHSLOPEDIFFS ...
//
#define FORT_FOURTHSLOPEDIFFS FORTRAN_NAME( FOURTHSLOPEDIFFS ,fourthslopediffs )
void 
FORT_FOURTHSLOPEDIFFS(
      CHFp_FRA(delta4WC)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_FRA(delta2W)
      ,CHFp_CONST_INT(numSlopes)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure APPLYFLAT ...
//
#define FORT_APPLYFLAT FORTRAN_NAME( APPLYFLAT ,applyflat )
void 
FORT_APPLYFLAT(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA1(flattening)
      ,CHFp_CONST_INT(numSlopes)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure VANLEERLIMITER ...
//
#define FORT_VANLEERLIMITER FORTRAN_NAME( VANLEERLIMITER ,vanleerlimiter )
void 
FORT_VANLEERLIMITER(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(dWleft)
      ,CHFp_CONST_FRA(dWright)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure DIVUEDGE ...
//
#define FORT_DIVUEDGE FORTRAN_NAME( DIVUEDGE ,divuedge )
void 
FORT_DIVUEDGE(
      CHFp_FRA1(divu)
      ,CHFp_CONST_FRA1(uNorm)
      ,CHFp_CONST_FRA(duTan)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure ARTVISC ...
//
#define FORT_ARTVISC FORTRAN_NAME( ARTVISC ,artvisc )
void 
FORT_ARTVISC(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(U)
      ,CHFp_CONST_FRA1(divu)
      ,CHFp_CONST_REAL(coeff)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

}

#endif
