#ifndef _PATCHPOLYTROPICGASF_F_H_
#define _PATCHPOLYTROPICGASF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure MAXWAVESPEED ...
//
#define FORT_MAXWAVESPEED FORTRAN_NAME( MAXWAVESPEED ,maxwavespeed )
void 
FORT_MAXWAVESPEED(
      CHFp_REAL(cmax)
      ,CHFp_CONST_FRA(cons)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CONSTOPRIM ...
//
#define FORT_CONSTOPRIM FORTRAN_NAME( CONSTOPRIM ,constoprim )
void 
FORT_CONSTOPRIM(
      CHFp_FRA(W)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure PRIMTOCONS ...
//
#define FORT_PRIMTOCONS FORTRAN_NAME( PRIMTOCONS ,primtocons )
void 
FORT_PRIMTOCONS(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(W)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure NORMALPRED ...
//
#define FORT_NORMALPRED FORTRAN_NAME( NORMALPRED ,normalpred )
void 
FORT_NORMALPRED(
      CHFp_FRA(WMinus)
      ,CHFp_FRA(WPlus)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_FRA(dW)
      ,CHFp_CONST_REAL(dtbydx)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RIEMANNF ...
//
#define FORT_RIEMANNF FORTRAN_NAME( RIEMANNF ,riemannf )
void 
FORT_RIEMANNF(
      CHFp_FRA(Wgdnv)
      ,CHFp_CONST_FRA(WLeft)
      ,CHFp_CONST_FRA(WRight)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETFLUX ...
//
#define FORT_GETFLUX FORTRAN_NAME( GETFLUX ,getflux )
void 
FORT_GETFLUX(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(Wgdnv)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure UPDATECONS ...
//
#define FORT_UPDATECONS FORTRAN_NAME( UPDATECONS ,updatecons )
void 
FORT_UPDATECONS(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(F)
      ,CHFp_CONST_REAL(dtbydx)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETRELGRAD ...
//
#define FORT_GETRELGRAD FORTRAN_NAME( GETRELGRAD ,getrelgrad )
void 
FORT_GETRELGRAD(
      CHFp_FRA1(du)
      ,CHFp_CONST_FRA1(u)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure GETJUMP ...
//
#define FORT_GETJUMP FORTRAN_NAME( GETJUMP ,getjump )
void 
FORT_GETJUMP(
      CHFp_FRA1(du)
      ,CHFp_CONST_FRA1(u)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure computepressure ...
//
#define FORT_COMPUTEPRESSURE FORTRAN_NAME( COMPUTEPRESSURE ,computepressure )
void 
FORT_COMPUTEPRESSURE(
      CHFp_FRA1(pressure)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

}

#endif
