#ifndef _RAMPF_F_H_
#define _RAMPF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure SETRAMP ...
//
#define FORT_SETRAMP FORTRAN_NAME( SETRAMP ,setramp )
void 
FORT_SETRAMP(
      CHFp_CONST_REAL(augamma)
      ,CHFp_CONST_REAL(aualpha)
      ,CHFp_CONST_REAL(aums)
      ,CHFp_CONST_REAL(auxcorner)
      ,CHFp_CONST_REAL(auartvisc) );

// Prototype for Fortran procedure RAMPINIT ...
//
#define FORT_RAMPINIT FORTRAN_NAME( RAMPINIT ,rampinit )
void 
FORT_RAMPINIT(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RAMPBC ...
//
#define FORT_RAMPBC FORTRAN_NAME( RAMPBC ,rampbc )
void 
FORT_RAMPBC(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RAMPSOLIDBC ...
//
#define FORT_RAMPSOLIDBC FORTRAN_NAME( RAMPSOLIDBC ,rampsolidbc )
void 
FORT_RAMPSOLIDBC(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(Wextrap)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RAMPSLOPEBCS ...
//
#define FORT_RAMPSLOPEBCS FORTRAN_NAME( RAMPSLOPEBCS ,rampslopebcs )
void 
FORT_RAMPSLOPEBCS(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi) );

// Prototype for Fortran procedure RAMPARTVISC ...
//
#define FORT_RAMPARTVISC FORTRAN_NAME( RAMPARTVISC ,rampartvisc )
void 
FORT_RAMPARTVISC(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(U)
      ,CHFp_CONST_FRA1(divu)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

}

#endif
